import { OnInit, AfterViewInit, ElementRef, OnDestroy, Renderer, OnChanges, SimpleChanges } from '@angular/core';
import { AgTableRowComponent } from '../ag-table-row/ag-table-row.component';
import { AgTableComponent } from '../ag-table/ag-table.component';
import { AgTableVirtualScrollModel } from '../models/ag-table-virtual-scroll.model';
import { AgTableVirtualScrollService } from '../services/ag-table-virtual-scroll.service';
import { Helper } from './../services/helper';
import { AgTableLangService } from '../services/ag-table-lang.service';
export declare class AgTableBodyComponent implements OnInit, OnChanges, AfterViewInit, OnDestroy {
    private langService;
    private renderer;
    private helper;
    elRef: ElementRef<HTMLElement>;
    private dataVirtualScrollService;
    class: boolean;
    clickable: boolean;
    readonly heightIsAuto: boolean;
    itemsContainerEl: ElementRef<HTMLElement>;
    private queryRows;
    private minHeight;
    rowHeight: string;
    emptyMsg: string;
    readonly rows: AgTableRowComponent[];
    readonly el: HTMLElement;
    parent: AgTableComponent;
    dictionary: {
        EMPTY: {
            ptBR: string;
            enUS: string;
        };
    };
    private subscription;
    scrollInBottom: boolean;
    scrollEnabled: boolean;
    virtualScroll: AgTableVirtualScrollModel;
    private lastScrollTop;
    private eventsLineters;
    constructor(langService: AgTableLangService, renderer: Renderer, helper: Helper, elRef: ElementRef<HTMLElement>, dataVirtualScrollService: AgTableVirtualScrollService);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    onRender(parent: AgTableComponent): void;
    private configureChildrens;
    private applyListeners;
    private dataTableInBottom;
    private onScrollFinished;
    onScroll(ev?: any, forceChange?: boolean): void;
    backToTheTop(): void;
    getRowIndexBasedVirtual(virtualIndex: number): number;
    private onMouseWheel;
    onBodyWidthChange(currentWidth: string): void;
    ngOnDestroy(): void;
}
