import { OnInit, OnChanges, SimpleChanges, ElementRef, AfterViewInit } from '@angular/core';
import { AgTableHeaderComponent } from '../ag-table-header/ag-table-header.component';
import { FormBuilder } from '@angular/forms';
import { AgTableFilterMode } from '../enums/ag-table-filter-mode.enum';
import { AgTableFilterType } from '../enums/ag-table-filter-type.enum';
import { Helper } from './../services/helper';
import { AgTableLangService } from '../services/ag-table-lang.service';
export declare class AgTableColComponent implements OnInit, OnChanges, AfterViewInit {
    private helper;
    private langService;
    private fb;
    private elRef;
    _class: boolean;
    width: string;
    customFilter: {
        field: string;
        mode?: AgTableFilterMode;
        value?: any;
    } | {
        field: string;
        mode?: AgTableFilterMode;
        value?: any;
    }[] | string | string[];
    filter: AgTableFilterType;
    field: string;
    mode: AgTableFilterMode;
    placeholder: string;
    dateFormat: string;
    optionAllLabel: string;
    options: {
        text: string;
        value: any;
    }[] | any[];
    noSort: boolean;
    noTruncate: boolean;
    sort: string;
    disableFilter: boolean;
    filterValue: any;
    _width: string;
    readonly el: HTMLElement;
    dictionary: {
        ALL_OPTION: {
            ptBR: string;
            enUS: string;
        };
        DATE_FORMAT: {
            ptBR: string;
            enUS: string;
        };
    };
    colIndex: number;
    parent: AgTableHeaderComponent;
    canFiltering: boolean;
    fields: string[];
    readonly canFilter: boolean;
    filterActive: boolean;
    readonly isSorting: boolean;
    readonly isSortAsc: boolean;
    constructor(helper: Helper, langService: AgTableLangService, fb: FormBuilder, elRef: ElementRef<HTMLElement>);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    makeFormControl(defaultValue?: any): import("@angular/forms").FormControl;
    onFiltering(): void;
    onFilterRender(): void;
    toggleSort(): void;
    private widthIsValid;
    private getWidthUnit;
    onRender(parent: AgTableHeaderComponent, index: any): void;
    private generateFieldsFilter;
    setWidth(): void;
    private setCellsWidth;
}
