import { OnInit, AfterViewInit, ElementRef, OnDestroy } from '@angular/core';
import { AgTableComponent } from '../ag-table/ag-table.component';
import { FormBuilder, FormGroup, AbstractControl } from '@angular/forms';
import { AgTableColComponent } from '../ag-table-col/ag-table-col.component';
import { Helper } from '../services/helper';
export declare class AgTableHeaderComponent implements OnInit, OnDestroy, AfterViewInit {
    elRef: ElementRef<HTMLElement>;
    private helper;
    private fb;
    class: boolean;
    private queryCols;
    readonly cols: AgTableColComponent[];
    readonly height: string;
    visible: boolean;
    parent: AgTableComponent;
    dictionary: {
        TITULO: {
            ptBR: string;
        };
    };
    frmFilter: FormGroup;
    colSorting: {
        col: AgTableColComponent;
        asc: boolean;
    };
    readonly filterCtrls: {
        [key: string]: AbstractControl;
    };
    readonly el: HTMLElement;
    constructor(elRef: ElementRef<HTMLElement>, helper: Helper, fb: FormBuilder);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    private makeForm;
    enableForm(): void;
    private checkFilterStatus;
    private checkDefaultValue;
    onRender(parent: AgTableComponent): void;
    configureChildrens(): void;
    getColByField(field: string): AgTableColComponent;
    getColFilterModeByField(field: string): any;
    getFormDataModel(): {};
    onBodyWidthChange(currentWidth: string): void;
    ngOnDestroy(): void;
}
