import { RouterModule } from '@angular/router';
import { Observable } from 'rxjs';
import { debounceTime, map } from 'rxjs/operators';
import { Injectable, Component, HostBinding, Pipe, Input, ChangeDetectorRef, ElementRef, Output, EventEmitter, ContentChildren, ViewContainerRef, Renderer, ViewChild, Directive, HostListener, NgModule, defineInjectable, inject } from '@angular/core';
import { DatePipe, CommonModule } from '@angular/common';
import { FormBuilder, FormsModule, ReactiveFormsModule } from '@angular/forms';
import { isNullOrUndefined, isObject, isArray } from 'util';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const TRANSLATION = {};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const TRANSLATION$1 = {
    TITULO: {
        ptBR: 'TITULO'
    }
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {string} */
const AgTableFilterMode = {
    CONTAINS: 'contains',
    EQUALS: 'equals',
    STARTS_WITH: 'startsWith',
    ENDS_WITH: 'endsWith',
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const TRANSLATION$2 = {
    ALL_OPTION: {
        ptBR: 'Todos',
        enUS: 'All'
    },
    DATE_FORMAT: {
        ptBR: 'dd/MM/yyyy',
        enUS: 'yyyy/MM/dd'
    }
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {string} */
const AgTableFilterType = {
    NONE: 'none',
    TEXT: 'text',
    SELECT: 'select',
    DATE: 'date',
    CURRENCY: 'currency',
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class Helper {
    constructor() {
        this.datePipe = new DatePipe('en-US');
    }
    /**
     * @param {?} text
     * @param {?=} qtty
     * @param {?=} char
     * @return {?}
     */
    padLeft(text, qtty = 2, char = 0) {
        if (!isNullOrUndefined(text))
            while (text.length < qtty)
                text = char + text;
        return text;
    }
    /**
     * @param {?} text
     * @param {?=} qtty
     * @param {?=} char
     * @return {?}
     */
    padRight(text, qtty = 2, char = 0) {
        if (!isNullOrUndefined(text))
            while (text.length < qtty)
                text += char;
        return text;
    }
    /**
     * @param {?=} min
     * @param {?=} max
     * @return {?}
     */
    randomNumber(min = 1, max = 9999) {
        /** @type {?} */
        let number = Math.floor(Math.random() * max);
        return Math.max(number, min);
    }
    /**
     * @param {?} text
     * @param {?=} exceptions
     * @return {?}
     */
    onlyNumbers(text, exceptions = null) {
        if (!isNullOrUndefined(text)) {
            /** @type {?} */
            let expression = (exceptions && exceptions.length) ? ('[^\\d|' + exceptions.join('|') + ']') : '[^\\d]';
            return text.replace(new RegExp(expression, 'g'), '');
        }
        return '';
    }
    /**
     * @param {?} text
     * @return {?}
     */
    onlyAlphaNumeric(text) {
        if (!isNullOrUndefined(text))
            return text.replace(/[^a-zA-Z0-9]+/g, '');
        return '';
    }
    /**
     * @param {?} text
     * @return {?}
     */
    onlyNumberAndToFloat(text) {
        if (text) {
            /** @type {?} */
            let strNumber = text.replace(/[^\d.\d]/g, '');
            /** @type {?} */
            let number = parseFloat(strNumber);
            if (!isNaN(number))
                return number;
        }
        return 0;
    }
    /**
     * @param {?} text
     * @return {?}
     */
    removeAccents(text) {
        return text ? text.normalize('NFD').replace(/[\u0300-\u036f]/g, '') : '';
    }
    /**
     * @param {?} date
     * @param {?=} dateFormat
     * @return {?}
     */
    dateIsValid(date, dateFormat) {
        return !isNullOrUndefined(this.strToDate(date, dateFormat));
    }
    /**
     * @param {?} date
     * @param {?=} separator
     * @return {?}
     */
    toAmericanDate(date, separator = '-') {
        if (date instanceof Date)
            date = this.dateToStr(date);
        if (this.dateIsValid(date)) {
            /** @type {?} */
            let dateStr = (/** @type {?} */ (date));
            if (dateStr && (dateStr.includes('-') || dateStr.includes('/'))) {
                if (dateStr.includes('/'))
                    dateStr = dateStr.replace(/\//g, '-');
                /** @type {?} */
                const dateSplited = dateStr.split('-');
                if (dateSplited.length >= 3) {
                    /** @type {?} */
                    const year = parseInt((dateSplited[0].length === 4) ? dateSplited[0] : dateSplited[2]);
                    /** @type {?} */
                    const month = parseInt(dateSplited[1]);
                    /** @type {?} */
                    const day = parseInt((dateSplited[0].length === 4) ? dateSplited[2] : dateSplited[0]);
                    /** @type {?} */
                    const arrayDate = [year, (month > 9 ? month : ('0' + month)), (day > 9 ? day : ('0' + day))];
                    return arrayDate.join(separator);
                }
            }
        }
        return (/** @type {?} */ (date));
    }
    /**
     * @param {?} date
     * @param {?=} dateFormat
     * @return {?}
     */
    strToDate(date, dateFormat) {
        if (typeof date === 'string' && (date.length >= 8 || dateFormat)) {
            /** @type {?} */
            let dateStr = ((/** @type {?} */ (date)));
            if (dateStr && (dateStr.includes('-') || dateStr.includes('/'))) {
                if (dateStr.includes('/'))
                    dateStr = dateStr.replace(/\//g, '-');
                dateStr = dateStr.substr(0, 10);
                if (dateFormat)
                    dateFormat = dateFormat.replace(/\//g, '-');
                /** @type {?} */
                const dateSplited = dateStr.split('-');
                /** @type {?} */
                const length = dateSplited.length;
                if (length >= 1) {
                    /** @type {?} */
                    let year = 1111;
                    /** @type {?} */
                    let month = 11;
                    /** @type {?} */
                    let day = 11;
                    if (length >= 3) {
                        year = parseInt((dateSplited[0].length === 4) ? dateSplited[0] : dateSplited[2]);
                        month = parseInt(dateSplited[1]);
                        day = parseInt((dateSplited[0].length === 4) ? dateSplited[2] : dateSplited[0]);
                    }
                    else if (dateFormat) {
                        /** @type {?} */
                        let i = 0;
                        for (let format of dateFormat.split('-')) {
                            try {
                                if (format.toLowerCase().startsWith('y'))
                                    year = parseInt(dateSplited[i]);
                                else if (format.toLowerCase().startsWith('m'))
                                    month = parseInt(dateSplited[i]);
                                else if (format.toLowerCase().startsWith('d'))
                                    day = parseInt(dateSplited[i]);
                            }
                            catch (_a) { }
                            i++;
                        }
                    }
                    /** @type {?} */
                    const arrayDate = [year, (month > 9 ? month : ('0' + month)), (day > 9 ? day : ('0' + day))];
                    dateStr = arrayDate.join('-');
                    if (dateStr)
                        return new Date(year, month - 1, day, 0, 0, 0);
                }
            }
        }
        else if (date instanceof Date)
            return (/** @type {?} */ (date));
        return null;
    }
    /**
     * @param {?} date
     * @param {?} days
     * @return {?}
     */
    setDaysToDate(date, days) {
        if (typeof date === 'string')
            date = this.strToDate(date);
        else if (date)
            date = this.copyDate(date);
        if (date && typeof days === 'number')
            return new Date(date.setDate(date.getDate() + days));
        return date;
    }
    /**
     * @param {?} date
     * @param {?=} format
     * @return {?}
     */
    dateToStr(date, format = 'dd/MM/yyyy') {
        if (!format)
            format = 'dd/MM/yyyy';
        format = format.replace(/mm/g, 'MM');
        if (date) {
            if (typeof date === 'string')
                date = this.strToDate(date);
            return this.datePipe.transform(date, format);
        }
        return null;
    }
    /**
     * @param {?=} withHours
     * @return {?}
     */
    getDateToday(withHours = false) {
        /** @type {?} */
        let today = new Date();
        if (withHours)
            return today;
        else
            return new Date(today.getFullYear(), today.getMonth(), today.getDate(), 0, 0, 0);
    }
    /**
     * @param {?} date
     * @return {?}
     */
    getYearOfDate(date) {
        date = this.strToDate(date);
        if (date)
            return date.getFullYear();
        return 0;
    }
    /**
     * @param {?} date
     * @return {?}
     */
    getMonthOfDate(date) {
        date = this.strToDate(date);
        if (date)
            return date.getMonth() + 1;
        return 0;
    }
    /**
     * @param {?} date
     * @return {?}
     */
    getDayOfDate(date) {
        date = this.strToDate(date);
        if (date)
            return date.getDate();
        return 0;
    }
    /**
     * @param {?} date
     * @return {?}
     */
    copyDate(date) {
        if (date)
            return new Date(date.toString());
        return date;
    }
    /**
     * @param {?} date
     * @param {?=} format
     * @return {?}
     */
    dateFormat(date, format = 'dd/MM/yyyy') {
        date = this.strToDate(date);
        if (date)
            return this.datePipe.transform(date, format);
        return null;
    }
    /**
     * @param {?} strCurrency
     * @return {?}
     */
    strToDoubleCurrency(strCurrency) {
        strCurrency = strCurrency.replace(/[,.]/g, (/**
         * @param {?} m
         * @return {?}
         */
        (m) => m === ',' ? '.' : ','));
        return Number(strCurrency);
    }
    /**
     * @param {?} obj
     * @return {?}
     */
    copy(obj) {
        if (obj)
            return JSON.parse(JSON.stringify(obj));
        else
            return obj;
    }
    /**
     * @param {?} inputElement
     * @return {?}
     */
    copyToClipboard(inputElement) {
        inputElement.focus();
        inputElement.select();
        /** @type {?} */
        let successful = document.execCommand('copy');
    }
    /**
     * @param {?} dateBegin
     * @param {?} dateEnd
     * @param {?=} returnType
     * @return {?}
     */
    getDiffOfDate(dateBegin, dateEnd, returnType = 'days') {
        if (dateBegin && dateEnd) {
            /** @type {?} */
            let delta = Math.abs(dateEnd.getTime() - dateBegin.getTime()) / 1000;
            /** @type {?} */
            let days = Math.floor(delta / 86400);
            delta -= days * 86400;
            /** @type {?} */
            let hours = Math.floor(delta / 3600) % 24;
            delta -= hours * 3600;
            /** @type {?} */
            let minutes = Math.floor(delta / 60) % 60;
            delta -= minutes * 60;
            /** @type {?} */
            let seconds = Math.floor(delta % 60);
            if (returnType === 'days')
                return days;
            else if (returnType === 'hours')
                return hours;
            else if (returnType === 'minutes')
                return minutes;
            else if (returnType === 'seconds')
                return seconds;
        }
        return 0;
    }
    /**
     * @param {?} source
     * @param {?} str
     * @param {?} strToRep
     * @return {?}
     */
    stringReplace(source, str, strToRep) {
        return source.replace(str, strToRep).toString();
    }
}
Helper.decorators = [
    { type: Injectable }
];
/** @nocollapse */
Helper.ctorParameters = () => [];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class AgTableCustomSettings {
    constructor() {
        this.lang = 'en-US';
    }
}
AgTableCustomSettings.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */ AgTableCustomSettings.ngInjectableDef = defineInjectable({ factory: function AgTableCustomSettings_Factory() { return new AgTableCustomSettings(); }, token: AgTableCustomSettings, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class AgTableSettings {
    /**
     * @param {?} customSettings
     */
    constructor(customSettings) {
        this.customSettings = customSettings;
        this.lang = 'en-US';
        Object.assign(this, this.customSettings);
    }
}
AgTableSettings.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
AgTableSettings.ctorParameters = () => [
    { type: AgTableCustomSettings }
];
/** @nocollapse */ AgTableSettings.ngInjectableDef = defineInjectable({ factory: function AgTableSettings_Factory() { return new AgTableSettings(inject(AgTableCustomSettings)); }, token: AgTableSettings, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class AgTableLangService {
    /**
     * @param {?} settings
     */
    constructor(settings) {
        this.settings = settings;
    }
    /**
     * @private
     * @param {?} value
     * @return {?}
     */
    set lang(value) { this.settings.lang = value; }
    /**
     * @private
     * @return {?}
     */
    get lang() { return this.settings.lang; }
    /**
     * @private
     * @return {?}
     */
    get langTranslation() { return this.lang.replace(/-/g, '').trim(); }
    /**
     * @param {?} lang
     * @param {?=} reloadPage
     * @return {?}
     */
    setLang(lang, reloadPage = false) {
        this.lang = lang;
        if (reloadPage)
            location.reload();
    }
    /**
     * @return {?}
     */
    getLang() { return this.lang; }
    /**
     * @param {?} value
     * @param {?} dict
     * @param {?=} asString
     * @return {?}
     */
    getText(value, dict, asString = true) {
        /** @type {?} */
        let getText = (/**
         * @param {?=} arg
         * @return {?}
         */
        (arg) => {
            /** @type {?} */
            let observ = arg ? (/** @type {?} */ (arg)) : null;
            if (!dict || JSON.stringify(dict) !== '{}') {
                /** @type {?} */
                let helper = this.processValue(value, dict);
                // tslint:disable-next-line:quotemark
                if (typeof helper === "object") {
                    /** @type {?} */
                    let text = `-- WITHOUT TRANSLATION [${value}] --`;
                    if (observ)
                        observ.next(text);
                    else
                        return text;
                }
                else {
                    if (observ)
                        observ.next(helper);
                    else
                        return helper;
                }
            }
            else {
                if (observ) {
                    if (dict && value in dict && this.langTranslation in dict[value])
                        observ.next(dict[value][this.langTranslation]);
                    else
                        observ.next('');
                }
                else {
                    if (dict && value in dict && this.langTranslation in dict[value])
                        return dict[value][this.langTranslation];
                    else
                        return '';
                }
            }
            if (observ)
                return (/**
                 * @return {?}
                 */
                () => observ.unsubscribe());
        });
        if (!asString)
            return new Observable(getText);
        else
            return getText();
    }
    /**
     * @private
     * @param {?} prop
     * @param {?=} dict
     * @return {?}
     */
    processValue(prop, dict) {
        /** @type {?} */
        const positions = prop.split('.');
        /** @type {?} */
        let helper = null;
        if (dict && JSON.stringify(dict) !== '{}') {
            helper = dict;
            for (let _prop of positions) {
                if (_prop in helper)
                    helper = helper[_prop];
            }
            if (this.langTranslation in helper)
                helper = helper[this.langTranslation];
        }
        return helper ? helper : '';
    }
}
AgTableLangService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
AgTableLangService.ctorParameters = () => [
    { type: AgTableSettings }
];
/** @nocollapse */ AgTableLangService.ngInjectableDef = defineInjectable({ factory: function AgTableLangService_Factory() { return new AgTableLangService(inject(AgTableSettings)); }, token: AgTableLangService, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class AgTableColComponent {
    /**
     * @param {?} helper
     * @param {?} langService
     * @param {?} fb
     * @param {?} elRef
     */
    constructor(helper, langService, fb, elRef) {
        this.helper = helper;
        this.langService = langService;
        this.fb = fb;
        this.elRef = elRef;
        this._class = true;
        this.width = null;
        this.filter = AgTableFilterType.NONE;
        this.field = '';
        this.mode = null;
        this.placeholder = '';
        this.dateFormat = '';
        this.optionAllLabel = '';
        this.options = [];
        /* DISABLED
            @Input('ready-only') public readOnly: boolean = false;
            @Input('min-date') public minDate: Date;
            @Input('max-date') public maxDate: Date;
            @Input('date-separator') public dateSeparator: string = '/'; */
        this.noSort = false;
        this.noTruncate = false;
        this.sort = null;
        this.disableFilter = false;
        this.filterValue = null;
        this.dictionary = TRANSLATION$2;
        this.colIndex = 0;
        this.canFiltering = false;
        this.fields = [];
        this.filterActive = false;
    }
    /**
     * @param {?} value
     * @return {?}
     */
    set _width(value) {
        if (this.el) {
            this.el.style.width = value;
            if (value && value.endsWith('%'))
                this.el.style.maxWidth = ((this.helper.onlyNumberAndToFloat(value) * this.parent.el.clientWidth) / 100) + 'px';
            else
                this.el.style.maxWidth = value;
        }
    }
    /**
     * @return {?}
     */
    get _width() { return (this.elRef && this.el) ? this.el.style.width : 'auto'; }
    /**
     * @return {?}
     */
    get el() { return (this.elRef && this.elRef.nativeElement) ? this.elRef.nativeElement : null; }
    /**
     * @return {?}
     */
    get canFilter() {
        return (this.filter && this.filter !== AgTableFilterType.NONE && this.filter.toString() !== '') ||
            (this.customFilter && ((/** @type {?} */ (this.customFilter))).length > 0);
    }
    /**
     * @return {?}
     */
    get isSorting() { return this.parent && this.parent.colSorting && this.parent.colSorting.col === this; }
    /**
     * @return {?}
     */
    get isSortAsc() { return this.isSorting && this.parent.colSorting.asc; }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
    /**
     * @return {?}
     */
    ngAfterViewInit() {
        if (!this.optionAllLabel)
            this.optionAllLabel = this.langService.getText('ALL_OPTION', this.dictionary);
        if (!this.dateFormat)
            this.dateFormat = this.langService.getText('DATE_FORMAT', this.dictionary);
        if (!this.noSort && !this.field && (!this.customFilter || !((/** @type {?} */ (this.customFilter))).length)) {
            this.filter = AgTableFilterType.NONE;
            console.warn(`The ordering will not applied because the [field] of column has not been defined.`);
        }
    }
    /**
     * @param {?} changes
     * @return {?}
     */
    ngOnChanges(changes) {
        if (!changes || 'width' in changes) {
            if (!this.widthIsValid())
                this.width = 'auto';
            if (this.widthIsValid() && this.helper.onlyNumbers(this.width) === this.width)
                this.width += 'px';
            if (this.parent && this.parent.cols) {
                /** @type {?} */
                let unit = this.getWidthUnit();
                if (unit !== '' && this.parent.cols.some((/**
                 * @param {?} x
                 * @return {?}
                 */
                (x) => x.getWidthUnit() !== '' && x.getWidthUnit() !== unit))) {
                    /** @type {?} */
                    let anotherUnit = this.parent.cols.find((/**
                     * @param {?} x
                     * @return {?}
                     */
                    (x) => x.getWidthUnit() !== '' && x.getWidthUnit() !== unit)).getWidthUnit();
                    console.warn(`A another column has width defined with like "${anotherUnit}". So this [width] was redefined as "auto".`);
                    this.width = 'auto';
                    this.setWidth();
                    return;
                }
            }
            if (this.getWidthUnit() === '%') {
                if (parseFloat(this.width.replace(this.getWidthUnit(), '')) >= 100) {
                    console.warn(`The columns cannot have width equal or greater than 100%.`);
                    this.width = 'auto';
                    this.setWidth();
                    return;
                }
            }
            this.setWidth();
        }
        if (changes) {
            if ('noSort' in changes)
                this.noSort = (typeof this.noSort === 'string' && (this.noSort === '' || this.noSort === 'true')) ? true : this.noSort;
            if ('noTruncate' in changes)
                this.noTruncate = (typeof this.noTruncate === 'string' && (this.noTruncate === '' || this.noTruncate === 'true')) ? true : this.noTruncate;
            if ('sort' in changes) {
                this.sort = !this.sort ? null : this.sort;
                if (this.sort !== 'asc' && this.sort !== 'desc')
                    this.sort = null;
                if (this.parent) {
                    this.parent.colSorting = {
                        col: this,
                        asc: this.sort === 'asc'
                    };
                    this.sort = null;
                    this.parent.parent.onSortChange();
                }
            }
            if ('filter' in changes) {
                if (!this.filter && this.filter.toString() !== '')
                    this.filter = AgTableFilterType.NONE;
                else if (this.filter.toString() === '')
                    this.filter = AgTableFilterType.TEXT;
                if (this.filter !== AgTableFilterType.NONE && !this.mode) {
                    switch (this.filter) {
                        case AgTableFilterType.TEXT:
                        case AgTableFilterType.CURRENCY:
                            this.mode = AgTableFilterMode.CONTAINS;
                            break;
                        case AgTableFilterType.SELECT:
                        case AgTableFilterType.DATE:
                            this.mode = AgTableFilterMode.EQUALS;
                            break;
                        default:
                            this.mode = AgTableFilterMode.CONTAINS;
                            break;
                    }
                }
                if (this.parent) {
                    if (this.field && this.parent.filterCtrls[this.field]) {
                        if (this.disableFilter)
                            this.parent.filterCtrls[this.field].disable();
                        else
                            this.parent.filterCtrls[this.field].enable();
                    }
                    else if (this.customFilter)
                        ((/** @type {?} */ (this.customFilter))).forEach((/**
                         * @param {?} custom
                         * @return {?}
                         */
                        (custom) => {
                            if (this.disableFilter)
                                this.parent.filterCtrls[custom.field].disable();
                            else
                                this.parent.filterCtrls[custom.field].enable();
                        }));
                }
                if (this.canFilter && !this.field) {
                    this.filter = AgTableFilterType.NONE;
                    console.warn(`The filter will not applied because the [field] of column has not been defined.`);
                }
                setTimeout((/**
                 * @return {?}
                 */
                () => {
                    if (this.parent)
                        this.parent.parent.definePaddingTop();
                }));
            }
            if ('customFilter' in changes) {
                if (this.canFilter && this.field) {
                    console.warn(`The [custom-filter] will not applied because the [filter] has already been defined.`);
                    this.customFilter = null;
                    return;
                }
                else {
                    if (this.customFilter && (isObject(this.customFilter) || typeof this.customFilter === 'string')) {
                        if (isObject(this.customFilter) && !isArray(this.customFilter))
                            this.customFilter = [((/** @type {?} */ (this.customFilter)))];
                        else if (isArray(this.customFilter) && (((/** @type {?} */ (this.customFilter))).length > 0 && typeof this.customFilter[0] === 'string'))
                            this.customFilter = ((/** @type {?} */ (this.customFilter))).map((/**
                             * @param {?} field
                             * @return {?}
                             */
                            field => ({ field })));
                        else if (!isObject(this.customFilter))
                            this.customFilter = (/** @type {?} */ ([{ field: this.customFilter }]));
                        if (!isArray(this.customFilter) || !((/** @type {?} */ (this.customFilter))).every((/**
                         * @param {?} x
                         * @return {?}
                         */
                        x => (isObject(x) && x.field) ? true : false))) {
                            console.warn(`The [custom-filter] will not applied because field has not been informed or is invalid. The value should look like this: { field: string, mode?: string }`);
                            this.customFilter = null;
                        }
                        else {
                            if (!this.noSort)
                                this.noSort = ((/** @type {?} */ (this.customFilter))).length > 1;
                            ((/** @type {?} */ (this.customFilter))).forEach((/**
                             * @param {?} filter
                             * @return {?}
                             */
                            (filter) => {
                                if (!filter.mode)
                                    filter.mode = AgTableFilterMode.CONTAINS;
                            }));
                            setTimeout((/**
                             * @return {?}
                             */
                            () => {
                                if (this.parent)
                                    this.parent.parent.definePaddingTop();
                            }));
                        }
                    }
                    else {
                        console.warn(`The [custom-filter] will not applied because value is invalid. The value should look like this: { field: string, mode?: string }`);
                        this.customFilter = null;
                    }
                }
            }
        }
    }
    /**
     * @param {?=} defaultValue
     * @return {?}
     */
    makeFormControl(defaultValue = null) {
        return this.fb.control(defaultValue);
    }
    /**
     * @return {?}
     */
    onFiltering() {
        if (this.parent && this.parent.parent) {
            if (this.parent) {
                if (this.field)
                    this.filterActive = (this.parent.filterCtrls[this.field] && this.parent.filterCtrls[this.field].value !== null);
                else if (this.customFilter)
                    this.filterActive = ((/** @type {?} */ (this.customFilter))).some((/**
                     * @param {?} custom
                     * @return {?}
                     */
                    (custom) => {
                        return this.parent.filterCtrls[custom.field] && this.parent.filterCtrls[custom.field].value !== null;
                    }));
            }
            else
                this.filterActive = false;
            this.parent.parent.onFilterChange();
        }
    }
    /**
     * @return {?}
     */
    onFilterRender() {
        if (this.parent)
            this.parent.parent.definePaddingTop();
    }
    /**
     * @return {?}
     */
    toggleSort() {
        if (this.parent && this.parent.parent && !this.parent.parent.loading) {
            /** @type {?} */
            let asc;
            if (this.isSorting) {
                if (this.parent.colSorting.asc) {
                    asc = false;
                    this.parent.colSorting = {
                        col: this,
                        asc: asc
                    };
                }
                else {
                    this.parent.colSorting = null;
                }
            }
            else {
                asc = true;
                this.parent.colSorting = {
                    col: this,
                    asc: asc
                };
            }
            this.parent.parent.onSortChange();
        }
    }
    /**
     * @private
     * @return {?}
     */
    widthIsValid() {
        return !isNullOrUndefined(this.width) && (typeof this.width === 'string') && this.width !== '' && this.width !== 'auto';
    }
    /**
     * @private
     * @return {?}
     */
    getWidthUnit() {
        return this.widthIsValid() ? this.width.replace(this.helper.onlyNumbers(this.width), '') : '';
    }
    /**
     * @param {?} parent
     * @param {?} index
     * @return {?}
     */
    onRender(parent, index) {
        this.parent = parent;
        this.colIndex = index;
        this.canFiltering = this.canFilter && !isNullOrUndefined(this.parent.filterCtrls);
        this.fields = this.generateFieldsFilter();
        this.setWidth();
        this.ngOnChanges(null);
    }
    /**
     * @private
     * @return {?}
     */
    generateFieldsFilter() {
        if (this.canFilter) {
            if (this.field)
                return [this.field];
            else
                return ((/** @type {?} */ (this.customFilter))).map((/**
                 * @param {?} custom
                 * @return {?}
                 */
                (custom) => custom.field));
        }
        return [];
    }
    /**
     * @return {?}
     */
    setWidth() {
        if (this.parent && this.parent.parent.body.itemsContainerEl && this.parent.parent.body.itemsContainerEl.nativeElement) {
            if (!this.widthIsValid()) {
                /** @type {?} */
                let unit = '';
                if (this.parent.cols.some((/**
                 * @param {?} x
                 * @param {?} i
                 * @return {?}
                 */
                (x, i) => x.getWidthUnit() !== '')))
                    unit = this.parent.cols.find((/**
                     * @param {?} x
                     * @param {?} i
                     * @return {?}
                     */
                    (x, i) => x.getWidthUnit() !== '')).getWidthUnit();
                if (unit === 'px') {
                    /** @type {?} */
                    let colsWithWidth = this.parent.cols.filter((/**
                     * @param {?} x
                     * @param {?} i
                     * @return {?}
                     */
                    (x, i) => i !== this.colIndex && x.widthIsValid()));
                    /** @type {?} */
                    let widthDiff = colsWithWidth.reduce((/**
                     * @param {?} prev
                     * @param {?} curr
                     * @return {?}
                     */
                    (prev, curr) => prev + parseFloat(this.helper.onlyNumbers(curr.width))), 0);
                    /** @type {?} */
                    let containerWidth = this.parent.el.clientWidth;
                    this._width = (containerWidth - widthDiff) / Math.abs(this.parent.cols.length - colsWithWidth.length) + 'px';
                }
                else {
                    if (!unit)
                        unit = '%';
                    /** @type {?} */
                    let colsWithWidth = this.parent.cols.filter((/**
                     * @param {?} x
                     * @param {?} i
                     * @return {?}
                     */
                    (x, i) => i !== this.colIndex && x.widthIsValid()));
                    /** @type {?} */
                    let widthDiff = colsWithWidth.reduce((/**
                     * @param {?} prev
                     * @param {?} curr
                     * @return {?}
                     */
                    (prev, curr) => prev + parseFloat(this.helper.onlyNumbers(curr.width))), 0);
                    this._width = (100 - widthDiff) / Math.abs(this.parent.cols.length - colsWithWidth.length) + unit;
                }
            }
            else
                this._width = this.width;
        }
        else
            this._width = 'auto';
        this.setCellsWidth();
    }
    /**
     * @private
     * @return {?}
     */
    setCellsWidth() {
        if (this.parent && this.parent.parent.body && this.parent.parent.body.rows.length) {
            this.parent.parent.body.rows.forEach((/**
             * @param {?} row
             * @return {?}
             */
            row => {
                /** @type {?} */
                let cell = row.cells.find((/**
                 * @param {?} cell
                 * @return {?}
                 */
                cell => cell.cellIndex === this.colIndex));
                if (cell)
                    cell.setWidth();
            }));
        }
    }
}
AgTableColComponent.decorators = [
    { type: Component, args: [{
                selector: 'ag-table-col',
                template: "<span *ngIf=\"!noSort\" class=\"ag-table-col-sort\" (click)=\"toggleSort()\" [ngClass]=\"{ 'sort-none': !isSorting, 'sort-asc': isSorting && isSortAsc, 'sort-desc': isSorting && !isSortAsc }\"></span>\r\n\r\n<div class=\"w-auto\" [ngClass]=\"{ 'text-truncate': !noTruncate && !customFilter }\">\r\n    <ng-content></ng-content>\r\n</div>\r\n\r\n<div *ngIf=\"canFiltering && parent?.filterCtrls\">\r\n    <ag-table-filter *ngFor=\"let field of fields\"\r\n        [frmControl]=\"parent?.filterCtrls[field]\"\r\n        [type]=\"filter\"\r\n        [placeholder]=\"placeholder\"\r\n        [dateFormat]=\"dateFormat\"\r\n        [optionAllLabel]=\"optionAllLabel\"\r\n        [options]=\"options\"\r\n        (onChange)=\"onFiltering()\" \r\n        (onRender)=\"onFilterRender()\"> \r\n    </ag-table-filter>\r\n</div>"
            }] }
];
/** @nocollapse */
AgTableColComponent.ctorParameters = () => [
    { type: Helper },
    { type: AgTableLangService },
    { type: FormBuilder },
    { type: ElementRef }
];
AgTableColComponent.propDecorators = {
    _class: [{ type: HostBinding, args: ['class.ag-table-col',] }],
    width: [{ type: Input }],
    customFilter: [{ type: Input, args: ['custom-filter',] }],
    filter: [{ type: Input }],
    field: [{ type: Input }],
    mode: [{ type: Input }],
    placeholder: [{ type: Input }],
    dateFormat: [{ type: Input, args: ['date-format',] }],
    optionAllLabel: [{ type: Input, args: ['option-all-label',] }],
    options: [{ type: Input }],
    noSort: [{ type: Input, args: ['no-sort',] }],
    noTruncate: [{ type: Input, args: ['no-truncate',] }],
    sort: [{ type: Input, args: ['sort',] }],
    disableFilter: [{ type: Input, args: ['disable-filter',] }],
    filterValue: [{ type: Input, args: ['filter-value',] }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class AgTableHeaderComponent {
    /**
     * @param {?} elRef
     * @param {?} helper
     * @param {?} fb
     */
    constructor(elRef, helper, fb) {
        this.elRef = elRef;
        this.helper = helper;
        this.fb = fb;
        this.class = true;
        this.dictionary = TRANSLATION$1;
        this.colSorting = null;
        this.frmFilter = this.fb.group({ none: [null] });
    }
    /**
     * @return {?}
     */
    get cols() { return this.queryCols ? this.queryCols.toArray() : []; }
    /**
     * @return {?}
     */
    get height() { return (this.el) ? `${this.el.children[0].clientHeight}px` : '0px'; }
    /**
     * @return {?}
     */
    get visible() { return (this.elRef && this.el) ? this.el.style.visibility !== 'hidden' : false; }
    /**
     * @param {?} value
     * @return {?}
     */
    set visible(value) {
        if ((this.elRef && this.el))
            this.el.style.visibility = (value ? '' : 'hidden');
    }
    /**
     * @return {?}
     */
    get filterCtrls() { return (this.frmFilter && this.frmFilter.controls) ? this.frmFilter.controls : null; }
    /**
     * @return {?}
     */
    get el() { return (this.elRef && this.elRef.nativeElement) ? this.elRef.nativeElement : null; }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
    /**
     * @return {?}
     */
    ngAfterViewInit() {
    }
    /**
     * @private
     * @return {?}
     */
    makeForm() {
        /** @type {?} */
        let objControls = {};
        this.cols.forEach((/**
         * @param {?} col
         * @return {?}
         */
        (col) => {
            if (col.canFilter) {
                if (col.field) {
                    objControls[col.field] = col.makeFormControl();
                    if (col.disableFilter) {
                        objControls[col.field].disable();
                    }
                }
                else {
                    ((/** @type {?} */ (col.customFilter))).forEach((/**
                     * @param {?} custom
                     * @return {?}
                     */
                    (custom) => {
                        objControls[custom.field] = col.makeFormControl(custom.value ? custom.value : null);
                        if (col.disableFilter) {
                            objControls[col.field].disable();
                        }
                    }));
                }
            }
        }));
        if (Object.keys(objControls).length === 0)
            objControls['none'] = this.fb.control(null);
        this.frmFilter = this.fb.group(objControls);
        if (this.parent && this.parent.loading)
            this.frmFilter.disable();
    }
    /**
     * @return {?}
     */
    enableForm() {
        this.cols.forEach((/**
         * @param {?} col
         * @return {?}
         */
        (col) => {
            if (col.canFilter) {
                if (col.field)
                    this.checkFilterStatus(col.field, col);
                else if (col.customFilter)
                    ((/** @type {?} */ (col.customFilter))).forEach((/**
                     * @param {?} custom
                     * @return {?}
                     */
                    (custom) => {
                        this.checkFilterStatus(custom.field, col);
                    }));
            }
        }));
    }
    /**
     * @private
     * @param {?} field
     * @param {?} col
     * @return {?}
     */
    checkFilterStatus(field, col) {
        /** @type {?} */
        let control = this.filterCtrls[field];
        if (control) {
            if (col.disableFilter)
                control.disable();
            else
                control.enable();
        }
    }
    /**
     * @private
     * @param {?} field
     * @param {?} value
     * @param {?} col
     * @return {?}
     */
    checkDefaultValue(field, value, col) {
        /** @type {?} */
        let control = this.filterCtrls[field];
        if (control && value)
            control.setValue(col.filterValue);
    }
    /**
     * @param {?} parent
     * @return {?}
     */
    onRender(parent) {
        this.parent = parent;
        this.configureChildrens();
        this.queryCols.changes.subscribe(this.configureChildrens.bind(this));
        this.onBodyWidthChange(this.parent.lastBodyWidth);
    }
    /**
     * @return {?}
     */
    configureChildrens() {
        this.makeForm();
        this.cols.forEach((/**
         * @param {?} col
         * @param {?} index
         * @return {?}
         */
        (col, index) => {
            col.onRender(this, index);
            if (col.field)
                this.checkDefaultValue(col.field, col.filterValue, col);
            else if (col.customFilter)
                ((/** @type {?} */ (col.customFilter))).forEach((/**
                 * @param {?} custom
                 * @return {?}
                 */
                (custom) => {
                    this.checkDefaultValue(custom.field, custom.value, col);
                }));
        }));
        if (this.colSorting) {
            if (this.parent.initialized)
                this.parent.onSortChange();
        }
        else if (this.cols.some((/**
         * @param {?} x
         * @return {?}
         */
        x => x.sort === 'asc' || x.sort === 'desc'))) {
            /** @type {?} */
            let colSort = this.cols.find((/**
             * @param {?} x
             * @return {?}
             */
            x => x.sort === 'asc' || x.sort === 'desc'));
            this.colSorting = {
                col: colSort,
                asc: colSort.sort === 'asc'
            };
            colSort.sort = null;
            if (this.parent.initialized)
                this.parent.onSortChange();
        }
        if (this.parent)
            this.parent.definePaddingTop();
    }
    /**
     * @param {?} field
     * @return {?}
     */
    getColByField(field) {
        return this.cols.find((/**
         * @param {?} col
         * @return {?}
         */
        col => {
            if (col.field)
                return col.field === field;
            else if (col.customFilter)
                return ((/** @type {?} */ (col.customFilter))).some((/**
                 * @param {?} x
                 * @return {?}
                 */
                x => x.field === field));
            return false;
        }));
    }
    /**
     * @param {?} field
     * @return {?}
     */
    getColFilterModeByField(field) {
        /** @type {?} */
        let col = this.getColByField(field);
        if (col) {
            if (col.field)
                return col.mode;
            else if (col.customFilter) {
                /** @type {?} */
                let customFilter = ((/** @type {?} */ (col.customFilter))).find((/**
                 * @param {?} x
                 * @return {?}
                 */
                x => x.field === field));
                if (customFilter)
                    return customFilter.mode;
            }
        }
        return AgTableFilterMode.CONTAINS;
    }
    /**
     * @return {?}
     */
    getFormDataModel() {
        /** @type {?} */
        let formValue = (/** @type {?} */ (this.frmFilter.value));
        /** @type {?} */
        let dataModel = {};
        for (let field in formValue) {
            /** @type {?} */
            let value = formValue[field];
            if (!isNullOrUndefined(value) && value !== '')
                dataModel[field] = value;
        }
        return dataModel;
    }
    /**
     * @param {?} currentWidth
     * @return {?}
     */
    onBodyWidthChange(currentWidth) {
        if (currentWidth && this.el) {
            /** @type {?} */
            let currentWidthNumber = this.helper.onlyNumberAndToFloat(currentWidth);
            if (this.cols.length > 0) {
                this.cols.forEach((/**
                 * @param {?} col
                 * @return {?}
                 */
                col => col.setWidth()));
                /** @type {?} */
                let lastCol = this.cols[this.cols.length - 1];
                if (this.el.clientWidth > currentWidthNumber) {
                    this.el.style.paddingRight = (this.el.clientWidth - currentWidthNumber) + 'px';
                    lastCol.el.style.paddingRight = '0px';
                }
                else {
                    this.el.style.paddingRight = '';
                    lastCol.el.style.paddingRight = '';
                }
            }
        }
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
    }
}
AgTableHeaderComponent.decorators = [
    { type: Component, args: [{
                selector: 'ag-table-header',
                template: "<form [formGroup]=\"frmFilter\">\r\n    <ng-content></ng-content>\r\n</form>"
            }] }
];
/** @nocollapse */
AgTableHeaderComponent.ctorParameters = () => [
    { type: ElementRef },
    { type: Helper },
    { type: FormBuilder }
];
AgTableHeaderComponent.propDecorators = {
    class: [{ type: HostBinding, args: ['class.ag-table-header',] }],
    queryCols: [{ type: ContentChildren, args: [AgTableColComponent,] }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const TRANSLATION$3 = {
    EMPTY: {
        ptBR: 'Você não tem dados para serem exibidos.',
        enUS: 'You do not have data to display.'
    }
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const TRANSLATION$4 = {};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const TRANSLATION$5 = {};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class AgTableCellComponent {
    /**
     * @param {?} elRef
     * @param {?} helper
     * @param {?} detectorRef
     */
    constructor(elRef, helper, detectorRef) {
        this.elRef = elRef;
        this.helper = helper;
        this.detectorRef = detectorRef;
        this.class = true;
        this.noTruncate = false;
        this.cellIndex = null;
        this.destroyed = false;
        this.dictionary = TRANSLATION$5;
        this.truncate = !this.noTruncate;
    }
    /**
     * @return {?}
     */
    get truncate() { return this.el.classList.contains('text-truncate'); }
    /**
     * @param {?} value
     * @return {?}
     */
    set truncate(value) {
        if (this.el) {
            if (value)
                this.el.classList.add('text-truncate');
            else
                this.el.classList.remove('text-truncate');
        }
    }
    /**
     * @return {?}
     */
    get col() {
        if (!isNullOrUndefined(this.cellIndex) &&
            this.parent &&
            this.parent.parent &&
            this.parent.parent.parent &&
            this.parent.parent.parent.header &&
            this.parent.parent.parent.header.cols) {
            if (this.cellIndex < this.parent.parent.parent.header.cols.length)
                return this.parent.parent.parent.header.cols[this.cellIndex];
            else {
                console.error('There are more cells than columns. Please fix this.');
                return null;
            }
        }
        return null;
    }
    /**
     * @private
     * @return {?}
     */
    get el() { return (this.elRef && this.elRef.nativeElement) ? this.elRef.nativeElement : null; }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
    /**
     * @param {?} changes
     * @return {?}
     */
    ngOnChanges(changes) {
        if (changes) {
            if ('noTruncate' in changes) {
                this.noTruncate = (typeof this.noTruncate === 'string' && (this.noTruncate === '' || this.noTruncate === 'true')) ? true : this.noTruncate;
                this.truncate = !this.noTruncate && (!this.parent || !this.parent.noTruncate);
            }
        }
    }
    /**
     * @param {?} parent
     * @param {?} index
     * @return {?}
     */
    onRender(parent, index) {
        this.cellIndex = index;
        this.parent = parent;
        this.truncate = !this.noTruncate && (!this.parent || !this.parent.noTruncate);
        this.setWidth();
    }
    /**
     * @return {?}
     */
    setWidth() {
        if (this.elRef && this.el) {
            /** @type {?} */
            let newWidth = this.col ? this.col._width : 'auto';
            /** @type {?} */
            let newMaxWidth = newWidth;
            if (newWidth && newWidth.endsWith('%'))
                newMaxWidth = ((this.helper.onlyNumberAndToFloat(newWidth) * this.parent.parent.el.clientWidth) / 100) + 'px';
            if (newWidth !== this.el.style.width || newMaxWidth !== this.el.style.maxWidth) {
                this.el.style.width = newWidth;
                this.el.style.maxWidth = newMaxWidth;
            }
        }
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
    }
}
AgTableCellComponent.decorators = [
    { type: Component, args: [{
                selector: 'ag-table-cell',
                template: "<ng-content></ng-content>"
            }] }
];
/** @nocollapse */
AgTableCellComponent.ctorParameters = () => [
    { type: ElementRef },
    { type: Helper },
    { type: ChangeDetectorRef }
];
AgTableCellComponent.propDecorators = {
    class: [{ type: HostBinding, args: ['class.ag-table-cell',] }],
    noTruncate: [{ type: Input, args: ['no-truncate',] }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class AgTableRowComponent {
    /**
     * @param {?} elRef
     * @param {?} viewContainer
     */
    constructor(elRef, viewContainer) {
        this.elRef = elRef;
        this.viewContainer = viewContainer;
        this.class = true;
        this.noTruncate = false;
        this.dictionary = TRANSLATION$4;
    }
    /**
     * @private
     * @param {?} value
     * @return {?}
     */
    set _height(value) {
        if (this.el) {
            this.el.style.minHeight = value;
            this.el.style.height = value;
        }
    }
    /**
     * @private
     * @return {?}
     */
    get _height() { return (this.el) ? this.el.style.minHeight : 'auto'; }
    /**
     * @return {?}
     */
    get cells() { return this.queryCells ? this.queryCells.toArray() : []; }
    /**
     * @return {?}
     */
    get el() { return (this.elRef && this.elRef.nativeElement) ? this.elRef.nativeElement : null; }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
    /**
     * @param {?} changes
     * @return {?}
     */
    ngOnChanges(changes) {
        if (changes) {
            if ('noTruncate' in changes) {
                this.noTruncate = (typeof this.noTruncate === 'string' && (this.noTruncate === '' || this.noTruncate === 'true')) ? true : this.noTruncate;
                if (this.cells.length)
                    this.cells.forEach((/**
                     * @param {?} cell
                     * @return {?}
                     */
                    cell => {
                        cell.truncate = !cell.noTruncate && !this.noTruncate;
                    }));
            }
        }
    }
    /**
     * @return {?}
     */
    ngAfterViewInit() {
    }
    /**
     * @param {?} parent
     * @param {?} virtualIndex
     * @return {?}
     */
    onRender(parent, virtualIndex) {
        this.parent = parent;
        this.virtualIndex = virtualIndex;
        this.index = this.parent.getRowIndexBasedVirtual(virtualIndex);
        this._height = this.parent.rowHeight;
        this.configureChildrens();
        this.defineClass();
        if (this.subscription)
            this.subscription.unsubscribe();
        this.subscription = this.queryCells.changes.subscribe(this.configureChildrens.bind(this));
    }
    /**
     * @return {?}
     */
    configureChildrens() {
        this.cells.forEach((/**
         * @param {?} cell
         * @param {?} index
         * @return {?}
         */
        (cell, index) => {
            cell.onRender(this, index);
        }));
    }
    /**
     * @private
     * @return {?}
     */
    defineClass() {
        if (this.index >= 0) {
            /** @type {?} */
            let position = this.index + 1;
            /** @type {?} */
            let currentClassName = 'ag-table-row-' + ((position % 2) === 0 ? 'even' : 'odd');
            /** @type {?} */
            let previousClassName = 'ag-table-row-' + ((position % 2) === 0 ? 'odd' : 'even');
            if (!this.el.classList.contains(currentClassName))
                this.el.classList.add(currentClassName);
            if (this.el.classList.contains(previousClassName))
                this.el.classList.remove(previousClassName);
        }
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
        if (this.subscription)
            this.subscription.unsubscribe();
    }
}
AgTableRowComponent.decorators = [
    { type: Component, args: [{
                selector: 'ag-table-row',
                template: "<ng-content></ng-content>"
            }] }
];
/** @nocollapse */
AgTableRowComponent.ctorParameters = () => [
    { type: ElementRef },
    { type: ViewContainerRef }
];
AgTableRowComponent.propDecorators = {
    class: [{ type: HostBinding, args: ['class.ag-table-row',] }],
    queryCells: [{ type: ContentChildren, args: [AgTableCellComponent,] }],
    noTruncate: [{ type: Input, args: ['no-truncate',] }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class AgTableVirtualScrollModel {
    /**
     * @param {?=} obj
     */
    constructor(obj) {
        this.currentStartIndex = 0;
        this.currentEndIndex = 0;
        this.totalHeightContent = 0;
        this.paddingScroll = 0;
        this.previousItemsHeight = [];
        if (obj)
            Object.assign(this, obj);
    }
    /**
     * @return {?}
     */
    get currentSrollTop() { return (this.containerSrollEl && this.containerSrollEl.nativeElement) ? this.containerSrollEl.nativeElement.scrollTop : 0; }
    /**
     * @return {?}
     */
    get scrollHeight() { return (this.containerSrollEl && this.containerSrollEl.nativeElement) ? this.containerSrollEl.nativeElement.scrollHeight : 0; }
    /**
     * @return {?}
     */
    get height() { return (this.containerSrollEl && this.containerSrollEl.nativeElement) ? this.containerSrollEl.nativeElement.clientHeight : 0; }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @template T
 */
class AgTableDataRenderEvent {
    /**
     * @param {?} obj
     */
    constructor(obj) {
        this.items = [];
        this.length = 0;
        this.startIndex = 0;
        this.endIndex = 0;
        Object.assign(this, obj);
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class AgTableVirtualScrollService {
    /**
     * @param {?} helper
     */
    constructor(helper) {
        this.helper = helper;
    }
    /**
     * @param {?} body
     * @return {?}
     */
    defineItens(body) {
        /** @type {?} */
        let vs = body.virtualScroll;
        /** @type {?} */
        let table = body.parent;
        /** @type {?} */
        let dimensions = this.defineDimensions(body);
        vs.paddingScroll = dimensions.paddingTop;
        vs.totalHeightContent = dimensions.heightAllItems;
        vs.currentStartIndex = dimensions.itemsThatAreGone;
        vs.currentEndIndex = vs.currentStartIndex + this.howManyCanAppear(body);
        table.items = table.filteredItems.slice(vs.currentStartIndex, vs.currentEndIndex);
        table.onDataRender.emit(new AgTableDataRenderEvent({
            items: table.items,
            length: table.items.length,
            startIndex: vs.currentStartIndex,
            endIndex: vs.currentEndIndex
        }));
        table.isDataEmpty = table.items.length === 0;
    }
    /**
     * @param {?} body
     * @return {?}
     */
    onScrollChange(body) {
        /** @type {?} */
        let vs = body.virtualScroll;
        for (let i = 0; i < body.itemsContainerEl.nativeElement.children.length; i++) {
            /** @type {?} */
            let children = body.itemsContainerEl.nativeElement.children[i];
            /** @type {?} */
            let realIndex = vs.currentStartIndex + i;
            if (!vs.previousItemsHeight[realIndex])
                vs.previousItemsHeight[realIndex] = children.getBoundingClientRect().height;
        }
        this.defineItens(body);
    }
    /**
     * @param {?} body
     * @return {?}
     */
    reset(body) {
        /** @type {?} */
        let vs = body.virtualScroll;
        vs.previousItemsHeight = [];
        vs.totalHeightContent = 0;
        vs.paddingScroll = 0;
    }
    /**
     * @param {?} body
     * @return {?}
     */
    defineDimensions(body) {
        /** @type {?} */
        let vs = body.virtualScroll;
        /** @type {?} */
        let rowHeight = parseInt(this.helper.onlyNumbers(body.rowHeight));
        /** @type {?} */
        let obj = {
            paddingTop: 0,
            itemsThatAreGone: 0,
            heightAllItems: 0
        };
        obj.heightAllItems = body.parent.filteredItems.reduce((/**
         * @param {?} prev
         * @param {?} curr
         * @param {?} i
         * @return {?}
         */
        (prev, curr, i) => {
            /** @type {?} */
            let height = vs.previousItemsHeight[i];
            return prev + (height ? height : rowHeight);
        }), 0);
        if (vs.currentSrollTop >= rowHeight) {
            /** @type {?} */
            let paddingTop = 0;
            /** @type {?} */
            let itemsThatAreGone = 0;
            /** @type {?} */
            let initialScroll = vs.currentSrollTop;
            for (let h of vs.previousItemsHeight) {
                /** @type {?} */
                let height = h ? h : rowHeight;
                if (initialScroll >= height) {
                    paddingTop += height;
                    initialScroll -= height;
                    itemsThatAreGone++;
                }
                else
                    break;
            }
            obj.paddingTop = paddingTop;
            obj.itemsThatAreGone = itemsThatAreGone;
        }
        return obj;
    }
    /**
     * @param {?} body
     * @return {?}
     */
    preparePreviousItemAfterDataChange(body) {
        /** @type {?} */
        let table = body.parent;
        /** @type {?} */
        let vs = body.virtualScroll;
        if (!table.infinity)
            vs.previousItemsHeight = new Array(table.filteredItems.length).fill(null);
        else {
            /** @type {?} */
            let anothers = table.filteredItems.length - vs.previousItemsHeight.length;
            if (anothers > 0)
                vs.previousItemsHeight = [...vs.previousItemsHeight, ...(new Array(anothers).fill(null))];
        }
    }
    /**
     * @param {?} body
     * @return {?}
     */
    canApplyVirtualScroll(body) {
        /** @type {?} */
        let vs = body.virtualScroll;
        if (body.parent && body.parent._height !== 'auto')
            return true;
        else {
            /** @type {?} */
            let rowHeight = parseInt(this.helper.onlyNumbers(body.rowHeight));
            /** @type {?} */
            let avaiableScrollHeight = vs.scrollHeight - vs.height;
            if (avaiableScrollHeight > rowHeight)
                return (avaiableScrollHeight / rowHeight) >= 1.5;
        }
        return false;
    }
    /**
     * @param {?} body
     * @return {?}
     */
    howManyCanAppear(body) {
        /** @type {?} */
        let vs = body.virtualScroll;
        /** @type {?} */
        let rowHeight = parseInt(this.helper.onlyNumbers(body.rowHeight));
        /** @type {?} */
        let height = vs.height ? vs.height : parseInt(this.helper.onlyNumbers(body.parent._height));
        return Math.floor((isNaN(height) ? 0 : height) / rowHeight) + 1;
    }
}
AgTableVirtualScrollService.decorators = [
    { type: Injectable }
];
/** @nocollapse */
AgTableVirtualScrollService.ctorParameters = () => [
    { type: Helper }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class AgTableBodyComponent {
    /**
     * @param {?} langService
     * @param {?} renderer
     * @param {?} helper
     * @param {?} elRef
     * @param {?} dataVirtualScrollService
     */
    constructor(langService, renderer, helper, elRef, dataVirtualScrollService) {
        this.langService = langService;
        this.renderer = renderer;
        this.helper = helper;
        this.elRef = elRef;
        this.dataVirtualScrollService = dataVirtualScrollService;
        this.class = true;
        this.clickable = false;
        this.minHeight = 40;
        this.rowHeight = this.minHeight + 'px';
        this.emptyMsg = '';
        this.dictionary = TRANSLATION$3;
        this.scrollInBottom = false;
        this.scrollEnabled = false;
        this.lastScrollTop = -1;
        this.eventsLineters = [];
    }
    /**
     * @return {?}
     */
    get heightIsAuto() { return this.parent && this.parent.height === 'auto'; }
    /**
     * @return {?}
     */
    get rows() { return this.queryRows ? this.queryRows.toArray() : []; }
    /**
     * @return {?}
     */
    get el() { return (this.elRef && this.elRef.nativeElement) ? this.elRef.nativeElement : null; }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.virtualScroll = new AgTableVirtualScrollModel({
            containerSrollEl: this.elRef
        });
    }
    /**
     * @return {?}
     */
    ngAfterViewInit() {
        if (!this.emptyMsg)
            this.emptyMsg = this.langService.getText('EMPTY', this.dictionary);
    }
    /**
     * @param {?} changes
     * @return {?}
     */
    ngOnChanges(changes) {
        if ('rowHeight' in changes) {
            if (this.helper.onlyNumbers(this.rowHeight) === this.rowHeight)
                this.rowHeight += 'px';
            if (isNullOrUndefined(this.rowHeight) || this.rowHeight === '') {
                this.rowHeight = this.minHeight + 'px';
                return;
            }
            else {
                /** @type {?} */
                let number = this.helper.onlyNumbers(this.rowHeight);
                /** @type {?} */
                let unit = this.rowHeight.replace(number, '');
                if (unit !== 'px') {
                    this.rowHeight = this.minHeight + 'px';
                    console.warn(`The row-height is invalid. The height must be informed in "px".`);
                    return;
                }
            }
            /** @type {?} */
            let number = parseInt(this.helper.onlyNumbers(this.rowHeight));
            if (number < this.minHeight) {
                this.rowHeight = this.minHeight + 'px';
                console.warn(`The row-height is invalid because the minimum height should be "${this.minHeight}px".`);
                return;
            }
        }
    }
    /**
     * @param {?} parent
     * @return {?}
     */
    onRender(parent) {
        this.parent = parent;
        this.configureChildrens();
        this.applyListeners();
        this.scrollEnabled = this.parent.loading;
        this.parent.checkMinWidthcanApply();
        if (this.dataVirtualScrollService.canApplyVirtualScroll(this))
            this.dataVirtualScrollService.defineItens(this);
        else
            this.parent.items = this.parent.filteredItems;
        if (this.subscription)
            this.subscription.unsubscribe();
        this.subscription = this.queryRows.changes.subscribe(this.configureChildrens.bind(this));
    }
    /**
     * @private
     * @return {?}
     */
    configureChildrens() {
        this.clickable = this.parent.clickable;
        this.rows.forEach((/**
         * @param {?} row
         * @param {?} index
         * @return {?}
         */
        (row, index) => {
            row.onRender(this, index);
        }));
    }
    /**
     * @private
     * @return {?}
     */
    applyListeners() {
        if (this.eventsLineters && this.eventsLineters.length) {
            this.eventsLineters.forEach((/**
             * @param {?} eventListener
             * @return {?}
             */
            (eventListener) => eventListener && eventListener()));
            this.eventsLineters = [];
        }
        this.eventsLineters.push(this.renderer.listen(this.elRef.nativeElement, 'scroll', this.onScroll.bind(this)));
        this.eventsLineters.push(this.renderer.listen(this.elRef.nativeElement, 'mousewheel', this.onMouseWheel.bind(this)));
        this.eventsLineters.push(this.renderer.listen(this.elRef.nativeElement, 'DOMMouseScroll', this.onMouseWheel.bind(this)));
    }
    /**
     * @private
     * @return {?}
     */
    dataTableInBottom() {
        /** @type {?} */
        let element = this.elRef.nativeElement;
        return element ? ((element.clientHeight + element.scrollTop) >= element.scrollHeight) : false;
    }
    /**
     * @private
     * @return {?}
     */
    onScrollFinished() {
        if (this.parent.infinity && this.parent && !this.parent.dataAreOver) {
            this.parent.currentPage++;
            this.parent.emitGetData();
        }
    }
    /**
     * @param {?=} ev
     * @param {?=} forceChange
     * @return {?}
     */
    onScroll(ev, forceChange = false) {
        if (!this.parent.loading) {
            if (this.dataTableInBottom()) {
                if (!this.scrollInBottom) {
                    this.scrollInBottom = true;
                    this.onScrollFinished();
                }
            }
            else
                this.scrollInBottom = false;
        }
        if (this.dataVirtualScrollService.canApplyVirtualScroll(this))
            if (forceChange || this.lastScrollTop !== this.virtualScroll.currentSrollTop) {
                this.lastScrollTop = this.virtualScroll.currentSrollTop;
                this.dataVirtualScrollService.onScrollChange(this);
            }
    }
    /**
     * @return {?}
     */
    backToTheTop() {
        this.el.scrollTop = 0;
    }
    /**
     * @param {?} virtualIndex
     * @return {?}
     */
    getRowIndexBasedVirtual(virtualIndex) {
        return this.virtualScroll.currentStartIndex + virtualIndex;
    }
    /**
     * @private
     * @return {?}
     */
    onMouseWheel() {
        if (!this.dataVirtualScrollService.canApplyVirtualScroll(this))
            this.onScroll();
    }
    /**
     * @param {?} currentWidth
     * @return {?}
     */
    onBodyWidthChange(currentWidth) {
        if (currentWidth && this.el) {
            if (this.rows.length)
                this.rows.forEach((/**
                 * @param {?} row
                 * @return {?}
                 */
                row => {
                    row.cells.forEach((/**
                     * @param {?} cell
                     * @return {?}
                     */
                    cell => cell.setWidth()));
                }));
        }
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
        if (this.subscription)
            this.subscription.unsubscribe();
        if (this.eventsLineters && this.eventsLineters.length) {
            this.eventsLineters.forEach((/**
             * @param {?} eventListener
             * @return {?}
             */
            (eventListener) => eventListener && eventListener()));
            this.eventsLineters = [];
        }
    }
}
AgTableBodyComponent.decorators = [
    { type: Component, args: [{
                selector: 'ag-table-body',
                template: "\r\n<section [style.height]=\"parent?.items.length ? '100%' : 'auto'\">\r\n    <div class=\"total-padding\" [style.height.px]=\"virtualScroll.totalHeightContent\"></div>\r\n    <div #itemsContainer class=\"scrollable-content\"\r\n        [ngClass]=\"{ 'p-relative': parent?.height === 'auto' }\"\r\n        [style.transform]=\"'translateY(' + virtualScroll.paddingScroll + 'px)'\"\r\n        [style.top.px]=\"(parent?.infinity && parent?.loading && parent?.currentPage > 1) ? -80 : 0\"\r\n    >\r\n        <ng-content></ng-content>\r\n    </div>\r\n</section>\r\n\r\n<div class=\"ag-table-empty animated fadeIn\" *ngIf=\"(parent && !parent.loading && !parent.noEmptyView) && rows && rows.length <= 0\">\r\n    <span [innerHTML]=\"emptyMsg\"></span>   \r\n</div>\r\n\r\n<div *ngIf=\"parent?.infinity\" class=\"ag-table-infinity\" [ngClass]=\"{'ag-table-infinity-show': parent?.loading && parent?.currentPage > 1}\" [style.width.px]=\"itemsContainer.clientWidth\">\r\n    <div>\r\n        <ag-table-spinner></ag-table-spinner>\r\n    </div>\r\n</div>"
            }] }
];
/** @nocollapse */
AgTableBodyComponent.ctorParameters = () => [
    { type: AgTableLangService },
    { type: Renderer },
    { type: Helper },
    { type: ElementRef },
    { type: AgTableVirtualScrollService }
];
AgTableBodyComponent.propDecorators = {
    class: [{ type: HostBinding, args: ['class.ag-table-body',] }],
    clickable: [{ type: HostBinding, args: ['class.clickable',] }],
    heightIsAuto: [{ type: HostBinding, args: ['class.height-is-auto',] }],
    itemsContainerEl: [{ type: ViewChild, args: ['itemsContainer',] }],
    queryRows: [{ type: ContentChildren, args: [AgTableRowComponent,] }],
    rowHeight: [{ type: Input, args: ['row-height',] }],
    emptyMsg: [{ type: Input, args: ['empty-msg',] }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {string} */
const AgTableChangeAction = {
    INITIALIZE: 'initialization',
    FILTER: 'filter',
    ORDER: 'order',
    PAGINATE: 'paginate',
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class AgTableEvent {
    /**
     * @param {?} obj
     */
    constructor(obj) {
        this.page = 1;
        this.pageSize = 0;
        this.order = (/** @type {?} */ ({}));
        this.resetData = false;
        Object.assign(this, obj);
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class AgTablePrepareService {
    /**
     * @param {?} helper
     */
    constructor(helper) {
        this.helper = helper;
    }
    /**
     * @param {?} data
     * @param {?} AgTable
     * @return {?}
     */
    apply(data, AgTable) {
        if (data && isArray(data) && data.length) {
            if (!AgTable.serverSide) {
                /** @type {?} */
                let _data;
                /** @type {?} */
                let length = data.length;
                /** @type {?} */
                let lengthPaginated = data.length;
                if (AgTable.isFiltering) {
                    _data = this.applyFilter(data, AgTable);
                    length = _data.length;
                }
                if (AgTable.isSorting) {
                    _data = this.applySort(_data ? _data : data, AgTable);
                    length = _data.length;
                }
                if (AgTable.isPaging) {
                    _data = this.applyPaginate(_data ? _data : data, AgTable);
                    lengthPaginated = _data.length;
                }
                AgTable.setDataLength(length, lengthPaginated);
                return _data ? _data : data;
            }
            return data;
        }
        else {
            if (!AgTable.serverSide)
                AgTable.setDataLength(0, 0);
            return [];
        }
    }
    /**
     * @private
     * @param {?} data
     * @param {?} table
     * @return {?}
     */
    applyFilter(data, table) {
        /** @type {?} */
        let header = table.header;
        /** @type {?} */
        let frm = header.frmFilter;
        if (table.actionChange === AgTableChangeAction.FILTER)
            table.setCurrentPage(1);
        /** @type {?} */
        let _data = data.filter((/**
         * @param {?} item
         * @return {?}
         */
        (item) => {
            /** @type {?} */
            let ok = true;
            for (let field in frm.controls) {
                /** @type {?} */
                let value;
                if (field.includes('.')) {
                    /** @type {?} */
                    let fields = field.split('.');
                    value = item[fields[0]];
                    fields.slice(1).forEach((/**
                     * @param {?} field
                     * @return {?}
                     */
                    field => {
                        if (isObject(value))
                            value = (field in value) ? value[field] : null;
                    }));
                }
                else
                    value = item[field];
                /** @type {?} */
                let filterCol = header.getColByField(field);
                /** @type {?} */
                let filterMode = header.getColFilterModeByField(field);
                /** @type {?} */
                let filterValue = frm.controls[field].value;
                if (filterCol && filterCol.filter === AgTableFilterType.DATE) {
                    value = this.helper.dateFormat(value, filterCol.dateFormat);
                    filterValue = filterValue;
                }
                else {
                    if (filterValue || (typeof filterValue === 'number'))
                        filterValue = this.helper.removeAccents((/** @type {?} */ (filterValue.toString()))).toUpperCase();
                    else
                        filterValue = '';
                    if ((value || (typeof value === 'number')))
                        value = this.helper.removeAccents((/** @type {?} */ (value.toString()))).toUpperCase();
                    else
                        value = '';
                }
                if (filterCol && !isNullOrUndefined(filterValue) && filterValue !== '') {
                    filterValue = this.helper.removeAccents((/** @type {?} */ (filterValue.toString()))).toUpperCase();
                    switch (filterMode) {
                        case AgTableFilterMode.CONTAINS:
                            ok = value.includes(filterValue);
                            break;
                        case AgTableFilterMode.EQUALS:
                            ok = value === filterValue;
                            break;
                        case AgTableFilterMode.STARTS_WITH:
                            ok = value.startsWith(filterValue);
                            break;
                        case AgTableFilterMode.ENDS_WITH:
                            ok = value.endsWith(filterValue);
                            break;
                    }
                }
                if (!ok)
                    break;
            }
            return ok;
        }));
        return _data;
    }
    /**
     * @private
     * @param {?} data
     * @param {?} table
     * @return {?}
     */
    applySort(data, table) {
        if (table.actionChange === AgTableChangeAction.ORDER)
            table.setCurrentPage(1);
        if (table.header.colSorting) {
            /** @type {?} */
            let col = table.header.colSorting.col;
            /** @type {?} */
            let asc = table.header.colSorting.asc;
            /** @type {?} */
            let field = '';
            if (!col.field && col.customFilter && ((/** @type {?} */ (col.customFilter))).length)
                field = ((/** @type {?} */ (col.customFilter)))[0].field;
            else
                field = col.field;
            /** @type {?} */
            let dateRegex = new RegExp('^(-?(?:[1-9][0-9]*)?[0-9]{4})-(1[0-2]|0[1-9])-(3[01]|0[1-9]|[12][0-9])T(2[0-3]|[01][0-9]):([0-5][0-9]):([0-5][0-9])(.[0-9]+)?(Z)?$');
            /** @type {?} */
            let _data = data.sort((/**
             * @param {?} a
             * @param {?} b
             * @return {?}
             */
            (a, b) => {
                /** @type {?} */
                let valueA = a[field];
                /** @type {?} */
                let valueB = b[field];
                if (typeof valueA === 'string' && dateRegex.test(valueA))
                    valueA = new Date(valueA);
                if (typeof valueB === 'string' && dateRegex.test(valueB))
                    valueB = new Date(valueB);
                if (typeof valueA === 'string' && !isNaN(parseFloat(valueA)))
                    valueA = parseFloat(valueA);
                if (typeof valueB === 'string' && !isNaN(parseFloat(valueB)))
                    valueB = parseFloat(valueB);
                if (valueA < valueB)
                    return asc ? -1 : 1;
                if (valueA > valueB)
                    return asc ? 1 : -1;
                return 0;
            }));
            return _data;
        }
        return data;
    }
    /**
     * @private
     * @param {?} data
     * @param {?} table
     * @return {?}
     */
    applyPaginate(data, table) {
        /** @type {?} */
        let currentPage = table.currentPage;
        /** @type {?} */
        let size = table.paginate;
        /** @type {?} */
        let begin = (currentPage - 1) * size;
        /** @type {?} */
        let end = begin + size;
        /** @type {?} */
        let _data = data.slice(begin, end);
        return _data;
    }
}
AgTablePrepareService.decorators = [
    { type: Injectable }
];
/** @nocollapse */
AgTablePrepareService.ctorParameters = () => [
    { type: Helper }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const TRANSLATION$6 = {
    TOTAL_CAPTION: {
        ptBR: 'Exibindo de {{start}} até {{end}} de {{total}} .',
        enUS: 'Displaying from {{start}} to {{end}} of {{total}} .'
    },
    WITHOUT_TOTAL_CAPTION: {
        ptBR: 'Exibindo de {{start}} até {{end}} registros.',
        enUS: 'Displaying from {{start}} to {{end}} records.'
    }
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class AgTablePaginateComponent {
    /**
     * @param {?} elRef
     */
    constructor(elRef) {
        this.elRef = elRef;
        this.class = true;
        this.length = 0;
        this.current = 1;
        this.disabled = false;
        this.loading = false;
        this.change = new EventEmitter();
        this.dictionary = TRANSLATION$6;
        this.pages = [];
    }
    /**
     * @return {?}
     */
    get el() { return (this.elRef && this.elRef.nativeElement) ? this.elRef.nativeElement : null; }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
    /**
     * @param {?} parent
     * @return {?}
     */
    onRender(parent) {
        this.parent = parent;
        this.parent.checkMinWidthcanApply();
    }
    /**
     * @param {?} changes
     * @return {?}
     */
    ngOnChanges(changes) {
        if ('length' in changes || 'current' in changes)
            this.generate();
    }
    /**
     * @param {?} page
     * @return {?}
     */
    pageClick(page) {
        if (!this.disabled && (typeof page) !== 'string' && page >= 1 && page <= this.length && page !== this.current) {
            this.current = (/** @type {?} */ (page));
            this.change.emit(this.current);
            this.generate();
        }
    }
    /**
     * @return {?}
     */
    generate() {
        /** @type {?} */
        let current = this.current;
        /** @type {?} */
        let last = this.length;
        /** @type {?} */
        let delta = 2;
        /** @type {?} */
        let left = current - delta;
        /** @type {?} */
        let right = current + delta + 1;
        /** @type {?} */
        let range = [];
        /** @type {?} */
        let rangeWithDots = [];
        /** @type {?} */
        let l;
        if (this.current > 0 && this.length > 0) {
            for (let i = 1; i <= last; i++) {
                if (i === 1 || i === last || i >= left && i < right)
                    range.push(i);
            }
            for (let i of range) {
                if (l) {
                    if (i - l === 2)
                        rangeWithDots.push(l + 1);
                    else if (i - l !== 1)
                        rangeWithDots.push('...');
                }
                rangeWithDots.push(i);
                l = i;
            }
        }
        this.pages = rangeWithDots;
    }
}
AgTablePaginateComponent.decorators = [
    { type: Component, args: [{
                selector: 'ag-table-paginate',
                template: "<span *ngIf=\"objCaption && !loading\" class=\"caption animated fadeIn\" [ngClass]=\"{ 'p-b-7': (length <= 1 || pages.length === 0) }\">\r\n\t{{ (objCaption.total ? 'TOTAL_CAPTION' : 'WITHOUT_TOTAL_CAPTION') | translate:dictionary:objCaption }}\r\n</span>\r\n\r\n<ul *ngIf=\"length > 1 && pages.length > 0\">\r\n\t<li [ngClass]=\"{'disabled': current <= 1}\" class=\"animated fadeIn\">\r\n\t\t<button (click)=\"pageClick(current - 1)\">\r\n\t\t\t<i class=\"arrow-prev\"></i>\r\n\t\t</button>\r\n\t</li>\r\n\t<li *ngFor=\"let page of pages\" class=\"animated fadeIn\"\r\n\t\t[ngClass]=\"{'actived': page === current, 'disabled': disabled, 'interval': page === '...'}\">\r\n\t\t<button (click)=\"pageClick(page)\">\r\n\t\t\t<span>{{page}}</span>\r\n\t\t</button>\r\n\t</li>\r\n\t<li [ngClass]=\"{'disabled': current >= length}\" class=\"animated fadeIn\">\r\n\t\t<button (click)=\"pageClick(current + 1)\">\r\n\t\t\t<i class=\"arrow-next\"></i>\r\n\t\t</button>\r\n\t</li>\r\n</ul>"
            }] }
];
/** @nocollapse */
AgTablePaginateComponent.ctorParameters = () => [
    { type: ElementRef }
];
AgTablePaginateComponent.propDecorators = {
    class: [{ type: HostBinding, args: ['class.ag-table-paginate',] }],
    length: [{ type: Input }],
    current: [{ type: Input }],
    disabled: [{ type: Input }],
    loading: [{ type: Input }],
    objCaption: [{ type: Input }],
    change: [{ type: Output }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class AgTableComponent {
    /**
     * @param {?} elRef
     * @param {?} helper
     * @param {?} dataPrepareService
     * @param {?} dataVirtualScrollService
     */
    constructor(elRef, helper, dataPrepareService, dataVirtualScrollService) {
        this.elRef = elRef;
        this.helper = helper;
        this.dataPrepareService = dataPrepareService;
        this.dataVirtualScrollService = dataVirtualScrollService;
        this.class = true;
        /**
         * THAT WILL DEFINE THE DATA TABLE HEIGHT, AND IT WILL HAS SCROLL BAR IN CASE OF OVERFLOW.
         */
        this.height = 'auto';
        /**
         * THIS DEFINE IF WILL GO PAGINATE OR NOT
         */
        this.paginate = null;
        /**
         * THIS DEFINE IF WILL GO BRING DATA BASED ON SCROLLING WHEN TO ARRIVE ON BOTTOM. (BUT USE THIS ONLY WITH SERVER-SIDE)
         */
        this.infinity = null;
        /**
         * SHOW LOADING SPINNER ABOVE THE DATA TABLE WHEN LOADING IS TRUE.
         */
        this.loading = null;
        /**
         * THE TOTAL DATA LENGTH. THIS IS USED FOR MAKE THE PAGINATION.
         */
        this.dataLength = 0;
        /**
         * DETERMINES WHETHER DATA WILL BE SWALLOWED VIA SERVER-SIDE
         */
        this.serverSide = false;
        /**
         * CALL REQUEST DATA ON INITIALIZATION DATA TABLE
         */
        this.getDataOnInit = false;
        /**
         * SET THE CURRENT PAGE WHEN USE PAGINATION
         */
        this.currentPage = 1;
        /**
         * Notifies that the data is gone (infinite-scroll only).
         */
        this.dataAreOver = false;
        /**
         * Sets whether to display empty-view or not.
         */
        this.noEmptyView = false;
        /**
         * Sets a minimum width in ag-table. When the minimum width is reached, the side table will scroll horizontally.
         */
        this.minWidth = '';
        this.allItems = [];
        /**
         * CALL/EMIT EVENT TO GET DATA (SERVER-SIDE)
         */
        this.onGetData = new EventEmitter();
        /**
         * EMIT EVENT WICH ITEMS HAVEN BEEN RENDERED
         */
        this.onDataRender = new EventEmitter();
        /**
         * EMIT EVENT WHEN THE ag-table HAS ALL BEEN RENDERED
         */
        this.onTableRender = new EventEmitter();
        this.filterActivated = new EventEmitter();
        this.items = [];
        this.filteredItems = [];
        this.dictionary = TRANSLATION;
        this.initialized = false;
        this.isDataEmpty = false;
        this.dataPaginatedLength = 0;
        this.actionChange = AgTableChangeAction.INITIALIZE;
        this.DOMisVisible = false;
        this.DOMcountVisibleChange = 0;
        this.lastBodyWidth = null;
        this.lastBodyHeight = null;
    }
    /**
     * @return {?}
     */
    get showEmptyView() { return this.isDataEmpty && !this.noEmptyView; }
    /**
     * @private
     * @return {?}
     */
    get paddingTop() { return this.elRef && this.elRef.nativeElement ? this.elRef.nativeElement.style.paddingTop : '0px'; }
    /**
     * @private
     * @param {?} value
     * @return {?}
     */
    set paddingTop(value) { if (this.elRef && this.elRef.nativeElement)
        this.elRef.nativeElement.style.paddingTop = value; }
    /**
     * @param {?} value
     * @return {?}
     */
    set _height(value) {
        this.el.style.height = value;
        if (this.header) {
            if (value === '0' || value === '0px')
                this.header.visible = false;
            else
                this.header.visible = true;
        }
        this.definePaddingTop();
    }
    /**
     * @return {?}
     */
    get _height() { return (this.el && this.el.style.height) ? this.el.style.height : 'auto'; }
    /**
     * @return {?}
     */
    get header() { return this.queryHeader ? this.queryHeader.first : null; }
    /**
     * @return {?}
     */
    get body() { return this.queryBody ? this.queryBody.first : null; }
    /**
     * @return {?}
     */
    get topShadow() {
        if (this.height !== 'auto') {
            /** @type {?} */
            let body = (this.body) ? this.body.el : null;
            /** @type {?} */
            let header = (this.header) ? this.header.el : null;
            if (body && header)
                return body.scrollTop >= (header.clientHeight / 2);
        }
        return false;
    }
    /**
     * @return {?}
     */
    get bottomShadow() {
        if (this.height !== 'auto') {
            /** @type {?} */
            let body = (this.body) ? this.body.el : null;
            /** @type {?} */
            let header = (this.header) ? this.header.el : null;
            if (body && header)
                return (body.scrollTop + body.clientHeight) < body.scrollHeight;
        }
        return false;
    }
    /**
     * @return {?}
     */
    get isPaging() { return this.paginate; }
    /**
     * @return {?}
     */
    get isSorting() { return this.header && this.header.colSorting; }
    /**
     * @return {?}
     */
    get isFiltering() { return ((this.header && this.header.cols) ? this.header.cols.some((/**
     * @param {?} x
     * @return {?}
     */
    x => x.canFilter)) : false); }
    /**
     * @return {?}
     */
    get numPages() {
        if (this.dataLength && this.isPaging) {
            /** @type {?} */
            let pages = Math.floor(this.dataLength / this.paginate);
            return pages + (((this.dataLength / this.paginate) > pages) ? 1 : 0);
        }
        else
            return 0;
    }
    /**
     * @return {?}
     */
    get el() { return (this.elRef && this.elRef.nativeElement) ? this.elRef.nativeElement : null; }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
    /**
     * @return {?}
     */
    ngAfterViewInit() {
        setTimeout((/**
         * @return {?}
         */
        () => {
            if (this.body.el) {
                this.lastBodyWidth = this.body.el.clientWidth + 'px';
                this.lastBodyHeight = this.body.el.clientHeight + 'px';
            }
            this.body.onRender(this);
            this.header.onRender(this);
            if (this.paginateComp)
                this.paginateComp.onRender(this);
            this.queryHeader.changes.subscribe((/**
             * @return {?}
             */
            () => this.definePaddingTop()));
            this.definePaddingTop();
            setTimeout((/**
             * @return {?}
             */
            () => this.onTableRender.emit()));
            if (this.getDataOnInit)
                this.emitGetData();
            if (this.infinity && !this.heightIsValid())
                console.warn(`The infinity scroll mode not working, because data table height has not been set.`);
            if (!this.infinity && this.body)
                this.body.backToTheTop();
            this.filterActivated.emit(false);
            this.initialized = true;
        }));
    }
    /**
     * @return {?}
     */
    ngAfterContentChecked() {
        if (this.elRef && this.elRef.nativeElement) {
            /** @type {?} */
            let elem = this.elRef.nativeElement;
            /** @type {?} */
            let visible = !!(elem.offsetWidth || elem.offsetHeight || elem.getClientRects().length);
            if (visible !== this.DOMisVisible) {
                this.DOMisVisible = visible;
                if (this.DOMisVisible && this.DOMcountVisibleChange > 0)
                    this.body.onScroll();
                this.DOMcountVisibleChange++;
            }
        }
        else
            this.DOMisVisible = false;
        this.onCheckBodyDimensions();
    }
    /**
     * @param {?} changes
     * @return {?}
     */
    ngOnChanges(changes) {
        setTimeout((/**
         * @return {?}
         */
        () => {
            if ('serverSide' in changes)
                this.serverSide = (typeof this.serverSide === 'string' && (this.serverSide === '' || this.serverSide === 'true')) ? true : this.serverSide;
            if ('noEmptyView' in changes)
                this.noEmptyView = (typeof this.noEmptyView === 'string' && (this.noEmptyView === '' || this.noEmptyView === 'true')) ? true : this.noEmptyView;
            if ('clickable' in changes) {
                this.clickable = (typeof this.clickable === 'string' && (this.clickable === '' || this.clickable === 'true')) ? true : this.clickable;
                if (this.body)
                    this.body.clickable = this.clickable;
            }
            if ('height' in changes) {
                if (this.height !== 'auto' && !this.heightIsValid()) {
                    console.warn(`The height of table is invalid.`);
                    this.height = 'auto';
                }
                this._height = this.height;
                this.prepareItemsPagingAndFilter();
                if (!this.infinity && this.body)
                    this.body.backToTheTop();
            }
            if ('minWidth' in changes) {
                if (!this.minWidthIsValid()) {
                    console.warn(`The min-width of table is invalid.`);
                    this.minWidth = '';
                }
                if (!this.minWidthIsValid())
                    this.stopListenerWidth();
                else
                    this.startListenerWidth();
            }
            if ('currentPage' in changes) {
                if (typeof this.currentPage === 'string') {
                    if (!isNaN(parseInt(this.currentPage)))
                        this.currentPage = parseInt(this.currentPage);
                    else {
                        console.warn(`The current-page value of table is invalid. The current-page value has been defined as 1.`);
                        this.currentPage = 1;
                    }
                }
                if (typeof this.currentPage !== 'number' || this.currentPage <= 0) {
                    console.warn(`The current-page value of table is invalid. The current-page value has been defined as 1.`);
                    this.currentPage = 1;
                }
                if (this.currentPage > this.paginate && this.currentPage < 1)
                    this.currentPage = 1;
                this.onPageChange(this.currentPage, !this.serverSide);
            }
            if ('paginate' in changes) {
                if (typeof this.paginate === 'string') {
                    if (!isNaN(parseInt(this.paginate)))
                        this.paginate = parseInt(this.paginate);
                    else {
                        console.warn(`The [paginate] value of table is invalid. The paginate has not been applied.`);
                        this.paginate = null;
                    }
                }
                if (this.isPaging && this.infinity) {
                    console.warn(`The [paginate] has not been applied because [infinity] already has been defined.`);
                    this.paginate = null;
                }
                if (this.paginate) {
                    if (this.currentPage > this.paginate)
                        this.currentPage = 1;
                    if (this.serverSide)
                        this.updatePaginateConfig();
                }
                this.onPageChange(this.currentPage, !this.serverSide);
                this.definePaddingBottom();
            }
            if ('infinity' in changes) {
                if (typeof this.infinity === 'string') {
                    if (!isNaN(parseInt(this.infinity)))
                        this.infinity = parseInt(this.infinity);
                    else {
                        console.warn(`The [infinity] value of table is invalid. The infinity scroll has not been applied.`);
                        this.infinity = null;
                    }
                }
                if (this.infinity && this.paginate) {
                    console.warn(`The [infinity] has not been applied because [paginate] already has been defined.`);
                    this.infinity = null;
                }
                this.onPageChange(this.currentPage, !this.serverSide);
                this.definePaddingBottom();
            }
            if ('dataLength' in changes) {
                if (isNullOrUndefined(this.dataLength))
                    this.dataLength = 0;
                this.updatePaginateConfig();
                this.definePaddingBottom();
            }
            if ('getDataOnInit' in changes)
                this.getDataOnInit = (typeof this.getDataOnInit === 'string' && (this.getDataOnInit === '' || this.getDataOnInit === 'true')) ? true : this.getDataOnInit;
            if ('loading' in changes) {
                setTimeout((/**
                 * @return {?}
                 */
                () => {
                    if (this.body)
                        this.body.scrollEnabled = this.loading;
                }));
                if (this._height.replace('px', '') === '0' && this.loading)
                    this.elRef.nativeElement.style.height = '50px';
                if (this.header && this.header.frmFilter) {
                    if (this.loading)
                        this.header.frmFilter.disable();
                    else {
                        this.header.enableForm();
                        this.updatePaginateConfig();
                    }
                }
            }
            if ('allItems' in changes) {
                if (!this.infinity && this.currentPage !== 1) {
                    /** @type {?} */
                    let maxPages = Math.floor(this.dataLength / this.paginate);
                    if ((this.dataLength % this.paginate) !== 0)
                        maxPages++;
                    if (this.currentPage > maxPages || !this.currentPage) {
                        this.currentPage = (this.currentPage > maxPages) ? maxPages : 1;
                        if (this.serverSide) {
                            this.onPageChange(this.currentPage);
                            return;
                        }
                    }
                }
                this.refreshRender();
            }
        }), 100);
    }
    /**
     * @private
     * @return {?}
     */
    onCheckBodyDimensions() {
        this.checkBodyWidthChange();
        this.checkBodyHeightChange();
    }
    /**
     * @private
     * @return {?}
     */
    checkBodyWidthChange() {
        if (this.el) {
            /** @type {?} */
            let currentWidth = '100%';
            if (this.body && this.body.itemsContainerEl && this.body.itemsContainerEl.nativeElement)
                currentWidth = this.body.itemsContainerEl.nativeElement.clientWidth + 'px';
            if (currentWidth !== this.lastBodyWidth) {
                this.lastBodyWidth = currentWidth;
                this.header.onBodyWidthChange(currentWidth);
                this.body.onBodyWidthChange(currentWidth);
            }
        }
    }
    /**
     * @private
     * @return {?}
     */
    checkBodyHeightChange() {
        if (this.el && this._height !== 'auto') {
            /** @type {?} */
            let currentHeight = this.el.clientHeight + 'px';
            if (currentHeight !== this.lastBodyHeight) {
                this.lastBodyHeight = currentHeight;
                this.refreshRender();
            }
        }
    }
    /**
     * @private
     * @return {?}
     */
    definePaddingBottom() {
        if (this.el) {
            /** @type {?} */
            let padding = '0px';
            if (!this.infinity && this.paginate !== null)
                padding = '46px';
            if (padding !== this.elRef.nativeElement.style.paddingBottom)
                this.el.style.paddingBottom = padding;
        }
    }
    /**
     * @param {?=} forceDefine
     * @return {?}
     */
    definePaddingTop(forceDefine = false) {
        if (this.el && this.header) {
            /** @type {?} */
            let padding = '0px';
            if (this.header && this.header.el && this.header.visible)
                padding = this.header.height;
            if (forceDefine || padding !== this.elRef.nativeElement.style.paddingTop) {
                this.paddingTop = padding;
                if (this.headerShadowEl && this.headerShadowEl.nativeElement)
                    this.headerShadowEl.nativeElement.style.height = padding !== '0px' ? padding : 'auto';
            }
        }
    }
    /**
     * @private
     * @return {?}
     */
    heightIsValid() {
        return !isNullOrUndefined(this.height) && (typeof this.height === 'string') && this.height !== '' && this.height !== 'auto';
    }
    /**
     * @private
     * @return {?}
     */
    minWidthIsValid() {
        return !isNullOrUndefined(this.minWidth) && (typeof this.minWidth === 'string') && this.minWidth !== '' && this.minWidth !== 'auto';
    }
    /**
     * @private
     * @return {?}
     */
    startListenerWidth() {
        this.stopListenerWidth();
        this.intervalListenerWidth = setInterval((/**
         * @return {?}
         */
        () => {
            if (this.el && this.minWidthIsValid()) {
                /** @type {?} */
                let width = this.el.clientWidth;
                /** @type {?} */
                let minWidth = parseInt(this.helper.onlyNumbers(this.minWidth));
                if (width <= minWidth) {
                    this.el.style.overflowX = 'auto';
                    this.el.style.overflowY = 'hidden';
                }
                else {
                    this.el.style.overflowX = '';
                    this.el.style.overflowY = '';
                }
            }
        }), 250);
    }
    /**
     * @private
     * @return {?}
     */
    stopListenerWidth() {
        if (this.intervalListenerWidth) {
            clearInterval(this.intervalListenerWidth);
            this.intervalListenerWidth = null;
        }
    }
    /**
     * @return {?}
     */
    checkMinWidthcanApply() {
        if (this.minWidthIsValid()) {
            if (this.el)
                this.body.el.style.minWidth = this.minWidth;
            if (this.paginateComp && this.paginateComp.el)
                this.paginateComp.el.style.minWidth = this.minWidth;
        }
        else {
            if (this.body && this.body.el)
                this.body.el.style.minWidth = '';
            if (this.paginateComp && this.paginateComp.el)
                this.paginateComp.el.style.minWidth = '';
        }
    }
    /**
     * @param {?} length
     * @param {?} paginatedLength
     * @return {?}
     */
    setDataLength(length, paginatedLength) {
        this.dataLength = length;
        this.dataPaginatedLength = paginatedLength;
    }
    /**
     * @param {?} currentPage
     * @param {?=} emit
     * @return {?}
     */
    onPageChange(currentPage, emit = true) {
        if (this.isPaging) {
            this.notifyChanges(AgTableChangeAction.PAGINATE);
            if (emit && this.serverSide) {
                this.setCurrentPage(currentPage);
                this.emitGetData();
            }
            else if (!this.serverSide) {
                this.setCurrentPage(currentPage, false);
                this.prepareItemsPagingAndFilter();
                this.updatePaginateConfig();
                this.body.backToTheTop();
            }
        }
    }
    /**
     * @return {?}
     */
    onSortChange() {
        this.notifyChanges(AgTableChangeAction.ORDER);
        if (this.serverSide) {
            this.setCurrentPage(1);
            this.emitGetData(this.infinity > 0);
        }
        else {
            this.prepareItemsPagingAndFilter();
            this.body.backToTheTop();
        }
    }
    /**
     * @return {?}
     */
    onFilterChange() {
        this.notifyChanges(AgTableChangeAction.FILTER);
        if (this.header && this.header.cols) {
            if (this.header.cols.some((/**
             * @param {?} x
             * @return {?}
             */
            x => x.filterActive))) {
                this.filterActivated.emit(true);
            }
            else {
                this.filterActivated.emit(false);
            }
        }
        if (this.serverSide) {
            this.setCurrentPage(1);
            this.emitGetData(this.infinity > 0);
        }
        else {
            this.prepareItemsPagingAndFilter();
            this.updatePaginateConfig();
            this.body.backToTheTop();
        }
    }
    /**
     * @private
     * @return {?}
     */
    prepareItemsPagingAndFilter() {
        this.filteredItems = this.dataPrepareService.apply(this.allItems, this);
        if (this.body && this.dataVirtualScrollService.canApplyVirtualScroll(this.body))
            this.dataVirtualScrollService.defineItens(this.body);
        else {
            this.items = this.filteredItems;
            this.isDataEmpty = this.items.length === 0;
            this.emitDataRender();
        }
    }
    /**
     * @param {?=} resetData
     * @return {?}
     */
    emitGetData(resetData = false) {
        if (resetData) {
            this.currentPage = 1;
            this.dataVirtualScrollService.reset(this.body);
        }
        /** @type {?} */
        let colSort = this.header.colSorting;
        this.onGetData.emit(new AgTableEvent({
            page: this.currentPage,
            pageSize: this.paginate ? this.paginate : this.infinity,
            filters: this.header.getFormDataModel(),
            order: colSort ? { field: colSort.col.field, asc: colSort.asc } : null,
            resetData: resetData
        }));
    }
    /**
     * @private
     * @return {?}
     */
    emitDataRender() {
        this.onDataRender.emit(new AgTableDataRenderEvent({
            items: this.items,
            length: this.items.length,
            startIndex: 0,
            endIndex: this.items.length - 1
        }));
    }
    /**
     * @param {?} page
     * @param {?=} updateConfig
     * @return {?}
     */
    setCurrentPage(page, updateConfig = true) {
        this.currentPage = page;
        if (updateConfig)
            this.updatePaginateConfig();
    }
    /**
     * @private
     * @return {?}
     */
    updatePaginateConfig() {
        /** @type {?} */
        let visibleLength = this.dataPaginatedLength;
        if (this.serverSide && this.body)
            visibleLength = this.filteredItems.length;
        /** @type {?} */
        let page = this.paginate ? this.paginate : this.infinity;
        this.paginateCaptionConfig = {
            start: (page * (this.currentPage - 1)) + 1,
            end: (page * (this.currentPage - 1)) + visibleLength,
            total: this.dataLength ? this.dataLength : 0
        };
    }
    /**
     * @private
     * @param {?=} action
     * @return {?}
     */
    notifyChanges(action = AgTableChangeAction.INITIALIZE) {
        this.actionChange = action;
    }
    /**
     * @param {?=} getData
     * @return {?}
     */
    resetFilters(getData = false) {
        for (let ctrlName in this.header.filterCtrls) {
            this.header.filterCtrls[ctrlName].reset();
        }
        if (getData)
            this.emitGetData(true);
    }
    /**
     * @return {?}
     */
    refreshRender() {
        if (this.body) {
            if (!this.body.parent)
                this.body.parent = this;
            this.dataVirtualScrollService.preparePreviousItemAfterDataChange(this.body);
        }
        this.prepareItemsPagingAndFilter();
        this.updatePaginateConfig();
        this.definePaddingBottom();
        if (!this.infinity && this.body)
            this.body.backToTheTop();
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
        this.stopListenerWidth();
    }
}
AgTableComponent.decorators = [
    { type: Component, args: [{
                selector: 'ag-table',
                template: "<div #headerShadowEl class=\"top-shadow animated fadeIn\" [ngClass]=\"{'to-drop': topShadow}\"></div>\r\n\r\n<ag-table-paginate *ngIf=\"!infinity && paginate !== null\"\r\n    class=\"animated fadeIn\"\r\n    [ngClass]=\"{ 'to-drop': bottomShadow, 'on-infinity': infinity }\"\r\n    [length]=\"(isPaging && numPages) ? numPages : 1\"\r\n    [current]=\"(isPaging && numPages) ? currentPage : 1\"\r\n    [objCaption]=\"(isPaging && numPages) ? paginateCaptionConfig : { start: 1, end: dataLength, total: 0 }\"\r\n    [loading]=\"loading\"\r\n    [disabled]=\"loading\"\r\n    (change)=\"onPageChange($event)\">\r\n</ag-table-paginate>\r\n\r\n<ng-content></ng-content>\r\n\r\n<div *ngIf=\"loading && (!infinity || currentPage === 1)\" class=\"ag-table-loading animated fadeIn\">\r\n    <ag-table-spinner></ag-table-spinner>\r\n</div>"
            }] }
];
/** @nocollapse */
AgTableComponent.ctorParameters = () => [
    { type: ElementRef },
    { type: Helper },
    { type: AgTablePrepareService },
    { type: AgTableVirtualScrollService }
];
AgTableComponent.propDecorators = {
    class: [{ type: HostBinding, args: ['class.ag-table',] }],
    showEmptyView: [{ type: HostBinding, args: ['class.ag-table-empty',] }],
    queryHeader: [{ type: ContentChildren, args: [AgTableHeaderComponent,] }],
    queryBody: [{ type: ContentChildren, args: [AgTableBodyComponent,] }],
    paginateComp: [{ type: ViewChild, args: [AgTablePaginateComponent,] }],
    headerShadowEl: [{ type: ViewChild, args: ['headerShadowEl',] }],
    loadingEl: [{ type: ViewChild, args: ['headerShadowEl',] }],
    height: [{ type: Input }],
    clickable: [{ type: Input }],
    paginate: [{ type: Input }],
    infinity: [{ type: Input }],
    loading: [{ type: Input }],
    dataLength: [{ type: Input, args: ['data-length',] }],
    serverSide: [{ type: Input, args: ['server-side',] }],
    getDataOnInit: [{ type: Input, args: ['get-data-init',] }],
    currentPage: [{ type: Input, args: ['current-page',] }],
    dataAreOver: [{ type: Input, args: ['data-are-over',] }],
    noEmptyView: [{ type: Input, args: ['no-empty-view',] }],
    minWidth: [{ type: Input, args: ['min-width',] }],
    allItems: [{ type: Input, args: ['items',] }],
    onGetData: [{ type: Output }],
    onDataRender: [{ type: Output }],
    onTableRender: [{ type: Output }],
    filterActivated: [{ type: Output }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const FILTER_TYPES = (/** @type {?} */ (Object.keys(AgTableFilterType).map((/**
 * @param {?} key
 * @return {?}
 */
key => AgTableFilterType[key]))));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const TRANSLATION$7 = {
    CURRENCY_PH: {
        ptBR: 'R$',
        enUS: 'USD'
    },
    DATE_FORMAT: {
        ptBR: 'dd/MM/yyyy',
        enUS: 'yyyy/MM/dd'
    },
    YEAR_INITIAL: {
        ptBR: 'a',
        enUS: 'y',
    }
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class AgTableFilterComponent {
    /**
     * @param {?} helper
     * @param {?} langService
     */
    constructor(helper, langService) {
        this.helper = helper;
        this.langService = langService;
        this.class = true;
        this.currentFilter = '';
        this.type = '';
        this.placeholder = '';
        this.dateFormat = '';
        this.optionAllLabel = '';
        this.options = [];
        /* DISABLED
            @Input() public readOnly: boolean = false;
            @Input() public minDate: Date;
            @Input() public maxDate: Date;
            @Input() public dateSeparator: string = '/'; */
        this.onChange = new EventEmitter();
        this.onRender = new EventEmitter();
        this.selectAllOptionValue = null;
        this.dictionary = TRANSLATION$7;
    }
    /**
     * @private
     * @return {?}
     */
    get debounceTime() {
        if (this.type === 'date' || this.type === 'select')
            return 0;
        else
            return 500;
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        setTimeout((/**
         * @return {?}
         */
        () => {
            this.onRender.emit();
        }));
    }
    /**
     * @param {?} changes
     * @return {?}
     */
    ngOnChanges(changes) {
        if ('options' in changes) {
            if (!isArray(this.options)) {
                console.warn('The options of a filter of type "select" was set invalid.');
                this.options = [];
            }
            else if (this.options.length) {
                if (!isObject(this.options[0])) {
                    this.options = ((/** @type {?} */ (this.options))).map((/**
                     * @param {?} x
                     * @return {?}
                     */
                    (x) => {
                        return {
                            text: x,
                            value: x
                        };
                    }));
                }
                else {
                    this.options = ((/** @type {?} */ (this.options))).map((/**
                     * @param {?} x
                     * @return {?}
                     */
                    (x) => {
                        return {
                            text: ('text' in x) ? x.text : x.value,
                            value: ('id' in x) ? x.id : x.value
                        };
                    }));
                }
            }
        }
        if ('type' in changes) {
            if (FILTER_TYPES.every((/**
             * @param {?} x
             * @return {?}
             */
            x => x !== this.type)))
                this.type = AgTableFilterType.TEXT;
        }
        if ('placeholder' in changes) {
            if (!this.placeholder && this.type === 'date')
                this.placeholder = this.dateFormat.replace(/y/g, this.langService.getText('YEAR_INITIAL', this.dictionary)).toUpperCase();
        }
        if ('frmControl' in changes) {
            if (this.subscription)
                this.subscription.unsubscribe();
            if (this.frmControl) {
                this.currentFilter = this.frmControl.value;
                this.subscription = this.frmControl.valueChanges.pipe(debounceTime(this.debounceTime), map(this.prepareData.bind(this))).subscribe((/**
                 * @param {?} toFilter
                 * @return {?}
                 */
                (toFilter) => {
                    if (toFilter && this.frmControl.enable)
                        this.onChange.emit(this.currentFilter);
                }));
            }
            else
                this.currentFilter = null;
        }
    }
    /**
     * @return {?}
     */
    prepareData() {
        if (this.frmControl.disabled) {
            this.frmControl.disable();
            return false;
        }
        if (this.type === 'select') {
            if (this.frmControl.value === 'undefined' || this.frmControl.value === 'null') {
                this.currentFilter = this.selectAllOptionValue;
                this.frmControl.setValue(this.currentFilter);
                return true;
            }
        }
        if (this.frmControl.value !== this.currentFilter) {
            if (this.type === 'date') {
                if (this.frmControl.value && !this.helper.dateIsValid(this.frmControl.value, this.dateFormat)) {
                    this.currentFilter = this.selectAllOptionValue;
                    this.frmControl.setValue(null);
                    return false;
                }
            }
            this.currentFilter = this.frmControl.value;
            if (typeof this.currentFilter === 'string' && this.currentFilter !== '') {
                if (this.currentFilter === 'null') {
                    this.currentFilter = null;
                    this.frmControl.setValue(this.currentFilter);
                }
                else if (this.currentFilter === 'undefined') {
                    this.currentFilter = undefined;
                    this.frmControl.setValue(this.currentFilter);
                }
                else if (this.helper.onlyNumbers(this.currentFilter) === this.currentFilter) {
                    this.currentFilter = parseInt(this.currentFilter);
                    this.frmControl.setValue(this.currentFilter);
                }
            }
        }
        else
            return false;
        return true;
    }
    /**
     * @private
     * @param {?} value
     * @return {?}
     */
    isEmptyValue(value) {
        return isNullOrUndefined(value) || value.toString() === '';
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
        if (this.subscription)
            this.subscription.unsubscribe();
    }
}
AgTableFilterComponent.decorators = [
    { type: Component, args: [{
                selector: 'ag-table-filter',
                template: "<input *ngIf=\"type === 'currency'\"\r\n    class=\"ag-table-filter-input\"\r\n    type=\"text\"\r\n    autocomplete=\"off\"\r\n    [formControl]=\"frmControl\"\r\n    [placeholder]=\"placeholder ? placeholder : (('CURRENCY_PH' | translate:dictionary) + ' 0,00')\"\r\n/>\r\n\r\n<select *ngIf=\"type === 'select'\" \r\n    class=\"ag-table-filter-select\"\r\n    [formControl]=\"frmControl\">\r\n    <option [value]=\"selectAllOptionValue\">{{optionAllLabel}}</option>\r\n    <option *ngFor=\"let option of options\" [value]=\"option.value\">{{option.text}}</option>\r\n</select>\r\n\r\n<input *ngIf=\"type === 'text'\"\r\n    class=\"ag-table-filter-input\"\r\n    [formControl]=\"frmControl\"\r\n    type=\"text\"\r\n    [placeholder]=\"placeholder ? placeholder : ''\"\r\n/>\r\n\r\n<input *ngIf=\"type === 'date'\"\r\n    class=\"ag-table-filter-input\"\r\n    [control]=\"frmControl\"\r\n    [date-format]=\"dateFormat\"\r\n    type=\"text\"\r\n    [placeholder]=\"placeholder ? placeholder : dateFormat.toUpperCase()\"\r\n/>\r\n\r\n<input *ngIf=\"type === 'number'\"\r\n    class=\"ag-table-filter-input\"\r\n    [formControl]=\"frmControl\"\r\n    type=\"text\"\r\n    OnlyNumber\r\n    [placeholder]=\"placeholder ? placeholder : ''\"\r\n/>\r\n"
            }] }
];
/** @nocollapse */
AgTableFilterComponent.ctorParameters = () => [
    { type: Helper },
    { type: AgTableLangService }
];
AgTableFilterComponent.propDecorators = {
    class: [{ type: HostBinding, args: ['class.ag-table-filter',] }],
    type: [{ type: Input }],
    placeholder: [{ type: Input }],
    dateFormat: [{ type: Input }],
    optionAllLabel: [{ type: Input }],
    options: [{ type: Input }],
    frmControl: [{ type: Input }],
    onChange: [{ type: Output }],
    onRender: [{ type: Output }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const TRANSLATION$8 = {};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class AgTableSpinnerComponent {
    constructor() {
        this.class = true;
        this.dictionary = TRANSLATION$8;
    }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
}
AgTableSpinnerComponent.decorators = [
    { type: Component, args: [{
                selector: 'ag-table-spinner',
                template: "<svg width=\"100\" height=\"100\" version=\"1.1\" xmlns=\"http://www.w3.org/2000/svg\">\r\n\t<circle cx=\"50\" cy=\"50\" r=\"25\" stroke-linecap=\"round\"/>\r\n</svg>"
            }] }
];
/** @nocollapse */
AgTableSpinnerComponent.ctorParameters = () => [];
AgTableSpinnerComponent.propDecorators = {
    class: [{ type: HostBinding, args: ['class.ag-table-spinner',] }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class TranslatePipe {
    /**
     * @param {?} langService
     */
    constructor(langService) {
        this.langService = langService;
    }
    /**
     * @param {?} prop
     * @param {?=} dict
     * @param {?=} replaceObj
     * @return {?}
     */
    transform(prop, dict = null, replaceObj) {
        /** @type {?} */
        let text = '';
        this.langService.getText(prop, dict, false).subscribe((/**
         * @param {?} result
         * @return {?}
         */
        result => {
            if (result !== undefined && typeof (result) === 'string') {
                if (replaceObj && (typeof replaceObj).includes('object')) {
                    for (let property in replaceObj)
                        result = result.replace(`{{${property}}}`, replaceObj[property]);
                }
                text = result;
            }
        }));
        return text;
    }
}
TranslatePipe.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] },
    { type: Pipe, args: [{
                name: 'translate',
                pure: false
            },] }
];
/** @nocollapse */
TranslatePipe.ctorParameters = () => [
    { type: AgTableLangService }
];
/** @nocollapse */ TranslatePipe.ngInjectableDef = defineInjectable({ factory: function TranslatePipe_Factory() { return new TranslatePipe(inject(AgTableLangService)); }, token: TranslatePipe, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class DateFormatDirective {
    /**
     * @param {?} helper
     * @param {?} settings
     */
    constructor(helper, settings) {
        this.helper = helper;
        this.settings = settings;
        this.keyCodesAccepts = [8, 9, 37, 38, 39, 40];
        this.ctrlDown = false;
        this.pasting = false;
        this.datePipe = new DatePipe(settings.lang);
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        /** @type {?} */
        let regexStr = '^\\d';
        if (this.dateFormat) {
            if (!this.dateFormat.includes('-') && !this.dateFormat.includes('/')) {
                if (this.dateFormat.toLowerCase() === 'dd')
                    regexStr += '(0[1-9]|[12][0-9]|3[01])$';
                else if (this.dateFormat.toLowerCase() === 'mm')
                    regexStr += '(0[1-9]|1[012])$';
                else if (this.dateFormat.toLowerCase() === 'yyyy')
                    regexStr += '{4}$';
            }
            else if (this.dateFormat.includes('-') || this.dateFormat.includes('/')) {
                this.dateSeparator = this.dateFormat.includes('-') ? '-' : '/';
                /** @type {?} */
                let splitted = this.dateFormat.split(this.dateSeparator);
                splitted.forEach((/**
                 * @param {?} division
                 * @param {?} i
                 * @return {?}
                 */
                (division, i) => {
                    /** @type {?} */
                    let divisionRegex = '';
                    if (division.toLowerCase() === 'dd')
                        divisionRegex = '(0[1-9]|[12][0-9]|3[01])';
                    else if (division.toLowerCase() === 'mm')
                        divisionRegex = '(0[1-9]|1[012])';
                    else if (division.toLowerCase() === 'yyyy')
                        divisionRegex = '{4}';
                    if (divisionRegex)
                        regexStr += (regexStr !== '^\\d' ? this.dateSeparator : '') + divisionRegex;
                }));
                regexStr += '$';
            }
        }
        if (regexStr === '^\\d') {
            this.dateSeparator = '/';
            this.dateFormat = 'dd/MM/yyyy';
            regexStr = '^\\d{4}/(0[1-9]|1[012])/(0[1-9]|[12][0-9]|3[01])$';
        }
        this.regex = new RegExp(regexStr, 'g');
    }
    /**
     * @param {?} e
     * @return {?}
     */
    onKeydown(e) {
        /** @type {?} */
        let input = (/** @type {?} */ (e.target));
        /** @type {?} */
        let code = e.keyCode;
        /** @type {?} */
        let key = e.key.toLowerCase();
        if (code == 17 || code == 91)
            this.ctrlDown = true;
        if (this.keyCodesAccepts.some((/**
         * @param {?} x
         * @return {?}
         */
        x => x === code)) || (this.ctrlDown && (code == 86 || code == 67 || key === 'a' || key === 'x'))) {
            if ((this.ctrlDown && key === 'x') || code === 8) {
                if ((input.selectionStart === 0 && input.selectionEnd === input.value.length) || input.value.length === 1)
                    setTimeout((/**
                     * @return {?}
                     */
                    () => this.onBlur(e)));
            }
        }
        else {
            /** @type {?} */
            let object = this.generateValue(input.value, e.key);
            if (!isNullOrUndefined(object.validValue.match(this.regex))) {
                input.value = object.formatedValue;
                if (input.value.length === this.dateFormat.length)
                    this.onBlur(e);
            }
            event.preventDefault();
            return false;
        }
    }
    /**
     * @param {?} e
     * @return {?}
     */
    onKeyup(e) {
        if (e.keyCode == 17 || e.keyCode == 91)
            this.ctrlDown = false;
    }
    /**
     * @param {?} e
     * @return {?}
     */
    onPaste(e) {
        if (!this.pasting) {
            /** @type {?} */
            let input = (/** @type {?} */ (e.target));
            /** @type {?} */
            let prevValue = input.value;
            this.pasting = true;
            setTimeout((/**
             * @return {?}
             */
            () => {
                this.pasting = false;
                /** @type {?} */
                let value = this.helper.onlyNumbers(input.value, [this.dateFormat]);
                /** @type {?} */
                let object = this.generateValue(value);
                if (!isNullOrUndefined(object.validValue.match(this.regex))) {
                    input.value = object.formatedValue;
                    if (input.value.length === this.dateFormat.length)
                        this.onBlur(e);
                }
                else
                    input.value = prevValue;
            }));
        }
    }
    /**
     * @param {?} e
     * @return {?}
     */
    onCut(e) {
        if (!this.pasting) {
            /** @type {?} */
            let input = (/** @type {?} */ (e.target));
            this.pasting = true;
            setTimeout((/**
             * @return {?}
             */
            () => {
                this.pasting = false;
                /** @type {?} */
                let value = this.helper.onlyNumbers(input.value, [this.dateFormat]);
                /** @type {?} */
                let object = this.generateValue(value);
                if (!isNullOrUndefined(object.validValue.match(this.regex))) {
                    input.value = object.formatedValue;
                }
                else
                    input.value = '';
                this.onBlur(e);
            }));
        }
    }
    /**
     * @param {?} e
     * @return {?}
     */
    onBlur(e) {
        if (this.formControl) {
            /** @type {?} */
            let input = (/** @type {?} */ (e.target));
            this.formControl.setValue(input.value);
        }
    }
    /**
     * @private
     * @param {?} currentValue
     * @param {?=} nextChar
     * @return {?}
     */
    generateValue(currentValue, nextChar = null) {
        /** @type {?} */
        let object = {
            validValue: currentValue,
            formatedValue: '',
        };
        if (currentValue.length !== this.dateFormat.length) {
            /** @type {?} */
            let newValue = '';
            if (this.dateSeparator) {
                for (var i = 0; i < this.dateFormat.length; i++) {
                    /** @type {?} */
                    let format = this.dateFormat[i];
                    /** @type {?} */
                    let length = i + 1;
                    if (length <= currentValue.length)
                        newValue += currentValue[i];
                    else if ((length - 1) === currentValue.length) {
                        if (format === this.dateSeparator) {
                            newValue += format;
                            if (nextChar)
                                i++;
                        }
                        newValue += nextChar ? nextChar : '1';
                        object.formatedValue = newValue;
                    }
                    else
                        newValue += (format !== this.dateSeparator) ? '1' : format;
                }
            }
            object.validValue = newValue;
        }
        if (!object.formatedValue)
            object.formatedValue = object.validValue;
        return object;
    }
    /**
     * @param {?} value
     * @return {?}
     */
    maskDate(value) {
    }
}
DateFormatDirective.decorators = [
    { type: Directive, args: [{
                selector: '[date-format]'
            },] }
];
/** @nocollapse */
DateFormatDirective.ctorParameters = () => [
    { type: Helper },
    { type: AgTableSettings }
];
DateFormatDirective.propDecorators = {
    dateFormat: [{ type: Input, args: ['date-format',] }],
    formControl: [{ type: Input, args: ['control',] }],
    onKeydown: [{ type: HostListener, args: ['keydown', ['$event'],] }],
    onKeyup: [{ type: HostListener, args: ['keyup', ['$event'],] }],
    onPaste: [{ type: HostListener, args: ['paste', ['$event'],] }],
    onCut: [{ type: HostListener, args: ['cut', ['$event'],] }],
    onBlur: [{ type: HostListener, args: ['blur', ['$event'],] }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class AgTableModule {
}
AgTableModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    CommonModule,
                    RouterModule,
                    FormsModule,
                    ReactiveFormsModule,
                ],
                declarations: [
                    AgTableComponent,
                    AgTableHeaderComponent,
                    AgTableBodyComponent,
                    AgTableRowComponent,
                    AgTableCellComponent,
                    AgTableColComponent,
                    AgTableFilterComponent,
                    AgTablePaginateComponent,
                    AgTableSpinnerComponent,
                    // Pipes
                    TranslatePipe,
                    // Directives
                    DateFormatDirective
                ],
                exports: [
                    AgTableComponent,
                    AgTableHeaderComponent,
                    AgTableBodyComponent,
                    AgTableRowComponent,
                    AgTableCellComponent,
                    AgTableColComponent
                ],
                bootstrap: [],
                providers: [
                    AgTablePrepareService,
                    AgTableVirtualScrollService,
                    AgTableCustomSettings,
                    AgTableSettings,
                    AgTableLangService,
                    Helper
                ],
                entryComponents: []
            },] },
    { type: Injectable }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { AgTableModule, AgTableCustomSettings, AgTableFilterMode, AgTableFilterType, AgTableEvent, AgTableDataRenderEvent, AgTableVirtualScrollModel, FILTER_TYPES, AgTableBodyComponent as ɵg, AgTableCellComponent as ɵi, AgTableColComponent as ɵc, AgTableFilterComponent as ɵm, AgTableHeaderComponent as ɵb, AgTablePaginateComponent as ɵk, AgTableRowComponent as ɵh, AgTableSpinnerComponent as ɵn, AgTableSettings as ɵf, AgTableComponent as ɵa, DateFormatDirective as ɵp, TranslatePipe as ɵo, AgTableLangService as ɵe, AgTablePrepareService as ɵl, AgTableVirtualScrollService as ɵj, Helper as ɵd };

//# sourceMappingURL=ag-table.js.map